#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>

#define inportb(__portid)           __inportb__(__portid)
#define outportb(__portid, __value) ((void) __outportb__(__portid, __value))

#include "tcu.h"
#include "timer.h"
#include "xms.h"	 // DW
#include "willem.h"

#define TSET 100
#define THLD 100
#define TDLY 200
#define RSET 100

#define LDCONF  0
#define LDPROG  2
#define RDPROG  4
#define INCADD  6
#define BEGPRG  8
#define LDDATA  3
#define RDDATA  5
#define ENDPROG 14

//#define VPPDLY  100    /* these are in milliseconds */
//#define PRGDLY  12

#define PROGRAM 0
#define DATA    1
#define PSIZE   1024
#define DSIZE   64

#define CP      16
#define PWRTE   8
#define WDTE    4
#define RC      3
#define HS      2
#define XT      1
#define LP      0

class microchip{
	public:
		int cp,wd,pt,osc;
		int fuses;
		int w7;
}mPIC;

#define INHX16  16
#define INHX8M  8
#define SWAB(w) (((w)>>8) + (((w)&0xFF)<<8))
#define MAX(a,b) ((a > b) ? a : b)

unsigned long image_highwater=0;
unsigned char inp_line[80];
unsigned bytes[80];

int picbuf[0x4000];
int progbuf[PSIZE];
int databuf[DSIZE];
// int fuses = XT;     //class microchip

int d_bits = 0;
int d_reg;
int s_reg;
int check;
int iport = 0;

// char bufile[20];
unsigned char stringbuf[100];
unsigned char *stringcha=(unsigned char *)"................";       // DW: added (unsigned char *)
int bits=0;int pin7=0;
int outbit=0;
int erase=0;int rb=1;int qe=1;
int PIC=0;int S3=0; int F84=0;
int C89=0;int C621=0;int C622=0;int C50=0;
int C93=0;
// A46=1,B46=0,B56=0,C56=0,C66=0;
int epr64=1;
// int hond,vijf,hvijf,tien,zes;
int zes;
int binl=1;int hexl=1;

int poort=0x378;int ipoort=0x379;int spoort=0x37a;
//------------------------------------------------
unsigned long  st=0;

char statbuf[15]="empty";char statdev[20]="27C64";
char statmet[8]="express";char statbur[10]="30";char statoff[8]="000000";
char statpin7[5]="low";
char statrb[4]="on";
char statqe[4]="on";
char statlpt[10]="lpt1";    //ARW: added. dont reduce size it gets longer later
char dip[32]=" ߳߳ܳ߳ܳ߳ܳܳ߳ܳ߳ܳ"; 	// DW: Added DIP switches 11 & 12

//------------------------------
int  sector_size,hardware_er;

//------------------------------
extern class spi25{
    private:
	    unsigned char mclock_in(void);
	    void mclock_out(int bit);
    public:
	    unsigned char wren,wrdi,rdsr,wrsr;
	    unsigned long rd,wr;
	    unsigned int adres,data,status;
	    unsigned char protect14,protect12,protectAL;

	    void init_code(void);
	    unsigned char spi_data(void);
	    void spi_command(unsigned char w);
	    unsigned char spi_read(unsigned long adres);
	    void spi_write(unsigned long adres,unsigned char data);
}AT25xxx;


extern class mcs51
{
    private:
	unsigned long P2_6,P2_7,P3_6,P3_7;
	unsigned long P33,P34,P35,P37;   	   // AT89Cx051
	unsigned long Prog,Clk,Rst,Pwrite,Pread,Plb1,Plb2,
		      Perase,Psig;
	unsigned long mode_wr,mode_rd,mode_erase, mode_sig,
		      mode_bit1, mode_bit2, mode_bit3;
	unsigned char p12,d;
	unsigned char Dout(unsigned char data);    // arrange D0-D7
	unsigned char Din(unsigned char data);
	void lockbit(unsigned long bit);

    public:
	unsigned char sig30,sig31,sig32;
	unsigned int  at89s,tWP,tWC,Pulses,type;
	void initl_code(void);
	void write_code(unsigned long address,unsigned char data);
	unsigned char read_code(unsigned long address);
	void write_mode_LB(int mode);
	void erase_chip(void);
	void read_sign(void);
	void inc_adres(void);  // AT89Cx051
	void setup(void);
}AT89Cxx;

extern class Eprom
{
    private:

    public:
	unsigned long size;
	unsigned int type1,type2,type3;
	unsigned int tWP,tWC;
	unsigned int sector_size;
	unsigned char flag_err;
}Epr;

extern class AT29C{

	public:
		unsigned char data[1024];
		unsigned int  Ssize,flag_err,tWC;
		unsigned long index_adres;
}at29Cxxx;

extern class m93c46{
    public:
	    unsigned int rd,wr,ewen,ewds,erase,eral,wral;
	    unsigned int adres,data,count_bit,bit16;
	    void init_code(void);
	    void shift_L(int shift);
	    void shift_R(int shift);

}m93Cxx;

//------------------------------

TCU_WINDOW  window1,window2,window3,window4,window5,window6,window7,window8;
int length;

char *Willem= "Willem's EpromProgrammer ";
char *Progver="August 28/2000 V0.992.67 ";            //ARW:

char  input_buffer[20];char filename[20];
FILE *fp ,*settings_fp;                              //ARW: added settings_fp

int pe=0,ep=1,burn=30,eep=0;
int fast=0;    //ARW: added fast intelligent mode 1ms pulses doubling till done
int e8751=0;   //ARW: 8751 type flag

unsigned long grot;
unsigned char huge rombuf[ROMBUFSIZ]; // DW: was rombuf[261344], but now this program uses XMS, so it can be smaller

unsigned long aantal= 0x2000;
char *headings[] = { "FFile", "DDevice", "PProgsettings","AAction","OOptions", NULL };

TCU_MENU file_m,device_m,settings_m,action_m,option_m,*mlist[6],test,bin,
	M24,M25,M27,M28,M28F,M29F,PICS,MPIC50,MPIC62,M93C,M27xx,AT29Cxx,
	MCS51,AT49Fxx,B_Block29C,LockBit89C,AT2051;

int  r1,r2;
char msg[26];
TCU_PULLDOWN  pd;

char *file_options[] =
	{ "LLoadfile","BLoadBin","HLoadHexIN","1LoadHexS1","3LoadHexS3",
	  "SSavebuffer","XSavebufheX","VViewbuffer","EExit","AAbout",NULL };
char *filen[] =
	{"             ","             ","             ","             ",
	 "             ","             ","             ","             ","             ","             ",
	 "             ","             ","             ","             ",
	 "             ","             ","             ","             ","             ","             ",NULL };
char *filbin[] =
	{"             ","             ","             ","             ",
	 "             ","             ","             ","             ","             ","             ",
	 "             ","             ","             ","             ",
	 "             ","             ","             ","             ","             ","             ",NULL };
char *device_options[] =
	{"24CXX","27CXX","28CXX","28FXX","29FXX","16C84","16F84",
	 "12C50X","16C6XX","93CXX","27xxx","29Cxxx","MCS-51","AT49Fxxx",
	 "89Cx051","AT25xxx",NULL };
char *E24C[]=
	{"24C02","24C04","24C08","24C16","24C32","24C65","24C128",
	 "24C256","24C512",NULL};
char *E25C[]=
	{"25010","25020","25040","25080","25160","25320","25640","25128","25256",NULL};
char *E27C[]=
	{"2732","27C64", "27C128", "27C256", "27C512","27C010",
	 "27C020","27C040",NULL};
char *E28C[]=
	{"28C64,65","28C128","28C256","28C512","28C010","28C020","28C040",NULL};
char *E28F[]=
	{"28F64","28F128", "28F256","28F512","28F010","28F020","28F040",NULL};
char *E29F[]=
	{"29F64","29F128", "29F256","29F512","29F010","29F020","29F040",NULL};
char *EPIC50[]=
	{"12C508","12C509",NULL};
char *EPIC62[]=
	{"16C620","16C621","16C622",NULL};
char *E93C[]=
	{"93C06  (8bit)", "93C46B (8bit)", "93LC46 (8bit)",
	 "93C56  (8bit)", "93C57  (A7-A0)","93C66  (8bit)",
	 "93C76  (8bit)", "93C86  (8bit)",
	 "93C06A (16bit)","93C46A (16bit)","93C56  (16bit)",
	 "93C66  (16bit)","93C76  (16bit)","93C86  (16bit)",NULL};
char *E27[]=
	{"2732","2764","27128","27256","27512","27010","27020",
	 "27040","87C257",NULL};
char *E29C[]=
	{"AT29C256  (64)" ,"AT29C512  (128)","AT29C010A (128)",
	 "AT29C020  (256)","AT29C040A (256)","AT29C040  (512)",
	 "W29EE512  (128)","W29EE011  (128)","W29C020   (128)",
	 "W29C040   (256)",NULL};
char *E_MCS51[]=
	{"Auto Select","AT89C51","AT89C52","AT89C55","AT89S8252",
	 "AT89S53","8xC51 4KB","8xC52 8KB","8xC54 16KB","8xC58 32KB",NULL};
char *E49F[]=
	{"AT49F512","AT49F010", "AT49F020","AT49F040",NULL};
char *E_AT2051[]=
	{"Auto Select","AT89C1051","AT89C2051","AT89C4051",NULL};
char *BB29C[]=
	{"Lockout lower address","Lockout higher address",NULL};
char *LB89C[]=
	{" Lock Mode 1 (No lock)",
	 " Lock Mode 2 bit 1     (MOVC)",
	 " Lock Mode 3 bit 1&2 (Verify)",
	 " Lock Mode 4 bit 1&2&3 (EXEc)",NULL};

char *settings_options[] =
	{"EExpress", "NNormal","BBurntime","OOffset","724Cpin7",
	 "SPICSettings","FFastErase","993Cxx 16bit or 8bit",NULL };
char *MPICS[]=
	{"CodeProtect","PUpTimer/MCLR","WatchDogTimer","OscType",NULL};
char *action_options[] =
	{ "RRead",
	  "PProgram",
	  "CCheckempty",
	  "MCoMpare",
	  "EErase 28x,29x,49x,89Cxx",
	  "AID Code ATxx",
	  "OBoot Block LockOut ATxx",
	  "LLock Modes 89C",
	  "IErasePIC",
	  "BClearBuffer",
	  "SCheckSumBuf",
	  "GProGram (Soft.Data Protect)",
	  "DDisable (Soft.Data Protect) ",NULL };
char *option_options[] =
	{ "1Lpt1", "2lpt2", "TTesthardware","RReadBreak",NULL };

//---------------------------------------------------
void about(void){			// DW: added void
	tcu_open_window(&window8, 20,10, 35,10,	 "about",
		 tcu_colour_attrib (WHITE, LIGHTBLUE),
		 tcu_colour_attrib (BLACK, LIGHTGRAY),
		 tcu_colour_attrib (YELLOW, BLUE),TCU_BOX_SINGLE);

	tcu_wprintf(&window8,"\n");
	tcu_wprintf(&window8," Ede Aug 28/2000 0.992.67\n");
	tcu_wprintf(&window8," 1.00 Freeware pre release\n");
	tcu_wprintf(&window8," See My HomePage at:\n");
	tcu_wprintf(&window8," http://www.willem.org (Org.)\n");
	tcu_wprintf(&window8," ------------OR---------------\n");
	tcu_wprintf(&window8," http://www.geocities.com/mpu51");
	getch();
	tcu_close_window(&window8);
}

void message(void){		// DW: added void
	tcu_open_window(&window8, 20,12, 36,11,"message",
		 tcu_colour_attrib (WHITE, LIGHTBLUE),
		 tcu_colour_attrib (BLACK, LIGHTGRAY),
		 tcu_colour_attrib (YELLOW, BLUE),TCU_BOX_SINGLE);

	reset_timer();	tcu_warnbeep(); setup_timer(0xb0);
	tcu_wprintf(&window8,"\n");
	tcu_wprintf(&window8," Not Implemented Yet\n");
	tcu_wprintf(&window8," See My HomePage at:\n");
	tcu_wprintf(&window8," http://www.willem.org/ (Org.)\n");
	tcu_wprintf(&window8," ------------or---------------\n");
	tcu_wprintf(&window8," http://www.geocities.com/mpu51\n");
	tcu_wprintf(&window8," for the latest update\n");
	tcu_wprintf(&window8," E-Mail: waklos@bos.nl\n");
	getch();
	tcu_close_window(&window8);
}

void rb_set(void){			// DW: added void
	if(rb){ rb=0;strcpy(statrb,"off");}
	else  { rb=1;strcpy(statrb,"on");}
	winstat();
}

//DW: Allocate an XMS buffer based on the new size
int Newaantal( unsigned long len )
{
	long old = aantal;

	if( len==aantal ) return 1;
	XMSFree();
	if( len>sizeof(rombuf) )
		if( AllocateXMS( rombuf, sizeof(rombuf), len ) ) {
			//ARW suspicious pointer conversion
			Newaantal(old);
			return 0;
		}
	aantal = len;
	return 1;
}

void viewbuffer(void)
{			// DW: added void
	unsigned char huge *hbuf, C;  // DW: huge
	long v;
	long p=0,m,y;

	tcu_open_window (&window5,1,1,80, 25, statbuf,
		 tcu_colour_attrib (WHITE, LIGHTBLUE),
		 tcu_colour_attrib (BLACK, LIGHTGRAY),
		 tcu_colour_attrib (CYAN, BLUE),TCU_BOX_DOUBLE);
	if(PIC){
		hbuf=(unsigned char huge *)picbuf;	// DW: added (unsigned char huge*)
		grot=20000;
	} else {
		hbuf=(unsigned char huge *)rombuf;	// DW: added (unsigned char huge*)
		grot=aantal;		// DW: added
	}
	do{
		for(m=p;m<336+p&&m<grot;m=m+16){	// DW: added m<grot
			for(v=0;v<16;v++){
				y=v+m;
				C=*(hbuf+XMSCurrent(y,0));		// DW: Made this XMS-aware
				sprintf((stringbuf+(v*3))," %0.2X",C); //ARW: mixed pointers +implicit conversion
				if(C<40||C>126)C=46;

				sprintf((stringcha+v),"%c",C);   //ARW: mixed pointers +implicit conversion
			}
			tcu_wprintf(&window5,"%0.8lX:",m);
			tcu_wprintf(&window5,stringbuf);
			tcu_wprintf(&window5," |");
			tcu_wprintf(&window5,stringcha);
			tcu_wprintf(&window5,"\n");
		}
		if(getch()==27) break;
		p=p+336;			// DW: was +500
	} while(p<grot);
	tcu_close_window(&window5);
}

void ChecksumBuf(void)
{			// DW
	unsigned char huge *hbuf;
	unsigned int calc_checksum=0;
	long y;

	if(PIC){
		hbuf=(unsigned char huge *)picbuf;	// DW: added (unsigned char huge*)
		grot=20000;
	} else {
		hbuf=(unsigned char huge *)rombuf;	// DW: added (unsigned char huge*)
		grot=aantal;
	}

	for( y=0; y<grot; y++ ){
		calc_checksum += *(hbuf+XMSCurrent(y,0));

	}
	tcu_open_window(&window6, 17,3, 40,3,"Buffer Checksum",
		tcu_colour_attrib (WHITE, LIGHTBLUE),
		tcu_colour_attrib (RED, LIGHTGRAY),
		tcu_colour_attrib (CYAN, BLUE),	TCU_BOX_SINGLE);
	tcu_clear_window(&window6);
	tcu_wprintf(&window6," Checksum: %04X", calc_checksum);
	getch();
	tcu_close_window(&window6);
}

void XMSError( char *err )
{
	tcu_open_window(&window4,14,10,55,3,"Memory Error",
		tcu_colour_attrib (WHITE, LIGHTBLUE),
		tcu_colour_attrib (RED, LIGHTGRAY),
		tcu_colour_attrib (CYAN, BLUE),TCU_BOX_SINGLE);
	tcu_clear_window(&window4);
	tcu_wprintf(&window4," %s", err);
	getch();
	tcu_close_window(&window4);
}

void versie(void)
{			// DW: added void
	int i,t,k;
	for(i=0;i<12;i++){
		tcu_wprintf(&window1," ");
		for(t=0;t<3;t++) tcu_wprintf(&window1,Willem);
		tcu_wprintf(&window1,"\n");
		tcu_wprintf(&window1," ");
		for(k=0;k<3;k++) tcu_wprintf(&window1,Progver);
		tcu_wprintf(&window1,"\n");
	}
}

void setup(void)			// DW: added void
{
	setup_timer(0xb0);   //ARW: sets up timer for two byte reload ie ms_delay
			     //ARW: NB must do a reset_timer() on all program exits
	r_adres(0); 	     //ARW: added, make sure we know where
	read,adrlo,pgrlo,ppoff,powoff,clklo,clalo,assert;asadres;
	ms_delay(25000);powon;assert;     //ARW: increased delays was 5,50
	ms_delay(30000);
}

void power_down(void)	 // ARW: added proc to set all lines to low on
{                        //exit to avoid cmos latchup & allow chip removal
	r_adres(0);      //ARW    crashes program without setup_timer(0x0b)
	pgrhi;assert;
	read,adrlo,ppoff,powoff,clklo,clalo,assert;asadres;
	r_adres(0);
	for(int i=0;i<3;i++) ms_delay(30000);  // delay 90 mS
	pgrlo;assert;
}

void idle_mode(void)		// DW: added void
{
	ppoff, adrlo, outlo, assert;asadres;
	ms_delay(TICKS(10000));
	powoff, assert;
}

void p5_mode(void)	        // DW: added void
{
	ppoff, clklo, outlo, assert;
	ms_delay(3000);

	power_down();		//ARW: added
	//powoff, assert;
}

void prog_mode(void)		// DW: added void
{
	ppoff, powon, adrlo, outlo, assert;asadres;
	ms_delay(TICKS(1000));
	ppon, assert;
	ms_delay(12000);
}

void pclock_out(int bit)	// DW: ANSIfied
{
	bit? outhi: outlo, adrhi, asadres;
	ms_delay(2);
	adrlo, asadres;
	ms_delay(2);
	outlo, asadres;
}

int pclock_in(void)			// DW: added void
{
	int b;

	outhi, adrhi, asadres;
	ms_delay(2);
	adrlo, asadres;
	b = einbit? 0: 1;
	ms_delay(2);
	return b;
}

void pout_word(int w)		// DW: ANSIfied
{
	int b;

	pclock_out(0);
	for ( b=0; b<14; ++b )  pclock_out(w&(1<<b));
	pclock_out(0);
}

int pin_word(void)			// DW: added void
{
	int b, w;

	(void) pclock_in();
	for ( w=0, b=0; b<14; ++b )
	  w += pclock_in()<<b;
	(void) pclock_in();
	return w;
}

void command(int cmd)		// DW: ANSIfied
{
	int b;

	outlo, asadres;
	ms_delay(5);
	for ( b=0; b<6; ++b ) pclock_out(cmd&(1<<b));
	outhi, asadres;
	ms_delay(5);
}

void P_erase(void)			// DW: added void
{
	int i;
	write;assert;

	prog_mode();
	command(LDCONF);
	pout_word(0x3FFF);
	for (i=0;i<7;++i) command(INCADD);
	command(1);
	command(7);
	command(BEGPRG);
	ms_delay(TICKS(12000));
	command(1);
	command(7);
	idle_mode();
	read;assert;

}

int verify(void)		// DW: ANSIfied, removed unused int which
{
	int i, w, mask, rdcmd;	// DW: also had *buf, ldcmd, n but they are unused
	long e=0; long t=PSIZE/52;
	show_action("verifying PIC program area",GREEN);

	write;assert;

	mask = 0x3FFF;

	rdcmd = RDPROG;
	prog_mode();
	for ( i=0; i<PSIZE; ++i ) {

		command(rdcmd);
		w = pin_word() & mask;
		if ( w != picbuf[i]) {
			tcu_wprintf(&window4,"error");
			reset_timer();	tcu_warnbeep(); setup_timer(0xb0);
			getch();
			idle_mode();
			return 0;
		}
		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	tcu_close_window(&window4);

	mask = 0xFF;

	rdcmd = RDDATA;
	prog_mode();
	ms_delay(12000);
	show_action("verifying PIC data area",GREEN);
	t=DSIZE/52;
	e=0;
	for ( i=0; i<DSIZE; ++i ) {
		command(rdcmd);
		w = pin_word() & mask;
		if ( w != picbuf[i+0x2100] ) {
			tcu_wprintf(&window4,"Error at 0x%X",i);		// DW: added offset
			reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
			power_down();
			getch();
			return 0;
		}

		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	tcu_close_window(&window4);
	idle_mode();
	read;assert;

	return 1;
}

int verify50(void)			// DW: ANSIfied, removed unused int which
{
	int i, w, mask, rdcmd;		//DW: *buf, ldcmd, n unused
	long e=0; long t=aantal/52;
	show_action("verifying PIC program area",GREEN);
	write;assert;

	mask = 0x3FFF;

	rdcmd = RDPROG;
	prog_mode();
	command(INCADD);
	for ( i=0; i<510; ++i ) {

		command(rdcmd);
		ms_delay(1200);
		w = pin_word() & mask;
		if ( w != picbuf[i]) {
			tcu_wprintf(&window4,"error at 0x%X",i);		// DW: added offset
			reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
			getch();
			return 0;
		}

		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	tcu_close_window(&window4);

	idle_mode();
	read;assert;
	return 1;
}

int config(void)			// DW: added void
{
	int i;
	mPIC.fuses=*(picbuf+0x2007);
	prog_mode();
	command(LDCONF);
	pout_word(mPIC.fuses);
	for ( i=0; i<7; ++i )
		command(INCADD);
	command(LDPROG);
	pout_word(mPIC.fuses);
	command(BEGPRG);
	ms_delay(TICKS(12000));
	command(RDPROG);
	if ( mPIC.fuses != (pin_word()&0x1F) ){
		tcu_wprintf(&window4,"error");
		idle_mode();
		reset_timer();	tcu_warnbeep();setup_timer(0xb0);
		getch();
		tcu_close_window(&window4);
		return 0;
	}
	return 1;
}

int Fconf(void)			// DW: added void, made return int
{
	int i;
	mPIC.fuses=19;
	prog_mode();
	command(LDCONF);
	pout_word(mPIC.fuses);
	for ( i=0; i<7; ++i )
		command(INCADD);
	command(1);
	command(7);

	command(BEGPRG);
	ms_delay(TICKS(12000));
	command(1);
	command(7);
	command(RDPROG);
	if ( mPIC.fuses != (pin_word()&0x1F) ){
		tcu_wprintf(&window4,"error");
		idle_mode();
		reset_timer();tcu_warnbeep(); setup_timer(0xb0);
		getch();
		tcu_close_window(&window4);
		return 0;
	}
	return 1;
}

void pr622(int i)
{
	command(LDPROG);
	ms_delay(1200);
	pout_word(picbuf[i]);
	ms_delay(4);
	command(BEGPRG);
	ms_delay(119);
	command(ENDPROG);
}

void PIC62_pr()
{
   int i, n,x, w, mask, ldcmd, rdcmd, *buf;
   long e=0;
   long t=aantal/52;
   int q=0;

   show_action("programming PIC program area");
      mask = 0x3FFF;
      ldcmd = LDPROG;
      rdcmd = RDPROG;
      prog_mode();
      for ( i=0; i<(aantal); ++i ) {
W:
      pr622(i);
      ms_delay(4);
      command(rdcmd);
       ms_delay(4);
      w = pin_word() & mask;
      if ( w != picbuf[i]) {
      q++;if(q>25)
      { reset_timer();
      tcu_warnbeep();tcu_wprintf(&window4,"error");idle_mode();
      getch();tcu_close_window(&window4);return;}
      else goto W;}
      for(x=0;x<(q*3);x++)pr622(i);
      command(INCADD);
      if(e==t){tcu_wprintf(&window4,"");e=0;}
      e++;q=0;
   }
   tcu_close_window(&window4);
   idle_mode();
	show_action("verifying PIC program area",GREEN);
	prog_mode();
	for ( i=0; i<aantal; ++i ) {

		command(rdcmd);
		w = pin_word() & mask;
		if ( w != picbuf[i]) {
			tcu_wprintf(&window4,"error");
			reset_timer();	tcu_warnbeep(); setup_timer(0xb0);
			getch();
			tcu_close_window(&window4);idle_mode();return;
		}
		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	tcu_close_window(&window4);
	show_action("programming PIC config area");

   tcu_wprintf(&window4,"                    blowing fuses");
   mPIC.fuses=*(picbuf+0x2007);
   prog_mode();
   command(LDCONF);
   pout_word(mPIC.fuses);
   for ( i=0; i<7; ++i )   command(INCADD);
   for ( i=0; i<100; ++i)  pr622(0x2007);
   command(RDPROG);
   if ( mPIC.fuses != (pin_word()&0x1F) ){
	tcu_warnbeep();tcu_wprintf(&window4,"error");getch();
   }
   delay(500);
   tcu_close_window(&window4);idle_mode();
   reset_timer();
}

void PIC508_pr(void)			// DW: added void
{
	int i, x, w,te, mask, rdcmd;	// DW: unused *buf, ldcmd, n
	long e=0;
	long t=aantal/52;
	int q=0;

	show_action("programming PIC program area");

	mask = 0x3FFF;
	rdcmd = RDPROG;
	write;assert;
	prog_mode();
	ms_delay(14);
	command(INCADD);
	for ( i=0; i<510; ++i ) {
W:
		pr622(i);
		ms_delay(4);
		command(rdcmd);
		ms_delay(4);
		w = pin_word() & mask;
		if ( w != picbuf[i]) {
			q++;
			if(q>25){
				idle_mode(); reset_timer();
				tcu_warnbeep();setup_timer(0xb0);tcu_wprintf(&window4,"error");
				getch();tcu_close_window(&window4);return;
			}else goto W;
		}
		for(x=0;x<(q*3);x++) pr622(i);
		command(INCADD);
		if(e==t){ tcu_wprintf(&window4,"");e=0; }
		e++;
		q=0;
	}
	tcu_close_window(&window4);
	if(verify50()){
		show_action("programming PIC config area");
		tcu_wprintf(&window4,"                    blowing fuses");
		mPIC.fuses=*(picbuf+0x2007);

		p5_mode();
		ms_delay(5000);
		prog_mode();

		ms_delay(4000);

		write;assert;
		for ( i=0; i<100; ++i )	pr622(0x2007);
		p5_mode();
		ms_delay(5000);
		prog_mode();
		command(RDPROG);
		te = pin_word()&0x1F;
		if ( mPIC.fuses != te) {
			p5_mode();
			reset_timer();
			tcu_warnbeep();setup_timer(0xb0);tcu_wprintf(&window4,"error");getch();
			tcu_close_window(&window4);
			return;
		}

		ms_delay(35000);
	}
	tcu_close_window(&window4);idle_mode();
	read;assert;

}

void P50read(void)			// DW: added void
{
	int i, mask, rdcmd;		// DW: unused   ldcmd, *buf, w, n
	long e=0; long t=aantal/52;
	show_action("reading PIC program area",BLACK);
	write;assert;

	mask = 0x3FFF;

	rdcmd = RDPROG;
	prog_mode();
	command(INCADD);
	for ( i=0; i<512; ++i ) {
		command(rdcmd);
		picbuf[i] = pin_word() & mask;
		command(INCADD);
		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
	}
	tcu_close_window(&window4);
	idle_mode();
	prog_mode();
	command(RDPROG);
	picbuf[0x2007]=pin_word()&0x1F;
	mPIC.fuses=picbuf[0x2007];
	R_50fuses();
	tcu_close_window(&window4);
	idle_mode();read;assert;
	strcpy(statbuf,"PicDump");winstat();
}

void PIC_pr(void)			// DW: ANSIfied, removed unused int which
{
	int i, w, mask, ldcmd, rdcmd; 	//DW: unused *buf,n
	long e=0; long t=PSIZE/52;

	P_erase();

	show_action("programming PIC program area");
	mask = 0x3FFF;
	ldcmd = LDPROG;
	rdcmd = RDPROG;
	prog_mode();
	write;assert;

	ms_delay(5000);
	for ( i=0; i<PSIZE; ++i ) {
		command(ldcmd);
		ms_delay(100);
		pout_word(picbuf[i]);
		ms_delay(100);
		command(BEGPRG);
		ms_delay(TICKS(12000));
		command(rdcmd);
		ms_delay(100);
		w = pin_word() & mask;
		if ( w != picbuf[i]) {
			tcu_wprintf(&window4,"error");
			idle_mode();reset_timer();tcu_warnbeep();setup_timer(0xb0);
			getch();
			tcu_close_window(&window4);
			return;
		}
		ms_delay(100);
		command(INCADD);
		ms_delay(100);
		if(e==t){tcu_wprintf(&window4,"");e=0;	}
		e++;
	}
	tcu_close_window(&window4);

	mask = 0xFF;
	ldcmd = LDDATA;
	rdcmd = RDDATA;
	prog_mode();
	show_action("programming PIC data area");
	t=DSIZE/52;e=0;
	for ( i=0; i<DSIZE; ++i ) {
		command(ldcmd);
		pout_word(picbuf[i+0x2100]);
		command(BEGPRG);
		ms_delay(TICKS(12000));
		command(rdcmd);
		w = pin_word() & mask;
		if ( w != picbuf[i+0x2100] ) {
			tcu_wprintf(&window4,"error");idle_mode();
			reset_timer();tcu_warnbeep(); setup_timer(0xb0);
			getch();tcu_close_window(&window4);
			return;
		}
		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	tcu_close_window(&window4);
	if(verify()){
		write;assert;
		show_action("programming PIC config area");
		tcu_wprintf(&window4,"                    blowing fuses");
		config();
	}
	ms_delay(35000);
	tcu_close_window(&window4);
	power_down();
}

void R_fuses(void){			// DW: added void
	mPIC.cp=(mPIC.fuses&CP)? CP: 0;
	mPIC.wd=(mPIC.fuses&WDTE)? WDTE: 0;
	mPIC.pt=(mPIC.fuses&PWRTE)? PWRTE: 0;
	if(F84) mPIC.pt=(mPIC.fuses&PWRTE)? 0: PWRTE;
	mPIC.osc=(mPIC.fuses&3);
	if(!mPIC.w7){
		tcu_open_window(&window7, 54,17, 22,7,
				"PIC conf status",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLUE, LIGHTGRAY),
				tcu_colour_attrib (CYAN, RED),
				TCU_BOX_SINGLE);
		mPIC.w7=1;
	}
	tcu_clear_window(&window7);
	tcu_wprintf(&window7,"\n   CodeProtect: ");
	if(!mPIC.cp) tcu_wprintf(&window7,"YES\n");
	else tcu_wprintf(&window7,"NO\n");
	tcu_wprintf(&window7,"  PowerUpTimer: ");
	if(mPIC.pt)tcu_wprintf(&window7,"YES\n");
	else tcu_wprintf(&window7,"NO\n");
	tcu_wprintf(&window7," WatchDogTimer: ");
	if(mPIC.wd)tcu_wprintf(&window7,"YES\n");
	else tcu_wprintf(&window7,"NO\n");
	tcu_wprintf(&window7," OscillatorTyp: ");
	if(mPIC.osc==0)tcu_wprintf(&window7,"LP");
	else if(mPIC.osc==1)tcu_wprintf(&window7,"XT");
	else if(mPIC.osc==2)tcu_wprintf(&window7,"HS");
	else if(mPIC.osc==3)tcu_wprintf(&window7,"RS");
}

void R_50fuses(void){			// DW: added void
	mPIC.cp=(mPIC.fuses&CP)? CP: 0;
	mPIC.wd=(mPIC.fuses&WDTE)? WDTE: 0;
	mPIC.pt=(mPIC.fuses&PWRTE)? PWRTE: 0;
	if(F84)mPIC.pt=(mPIC.fuses&PWRTE)? 0: PWRTE;
	mPIC.osc=(mPIC.fuses&3);
	if(!mPIC.w7){
		tcu_open_window(&window7, 54,17, 22,7,
				"PIC conf status",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLUE, LIGHTGRAY),
				tcu_colour_attrib (CYAN, RED),
				TCU_BOX_SINGLE);
		mPIC.w7=1;
	}
	tcu_clear_window(&window7);
	tcu_wprintf(&window7,"  CodeProtect: ");
	if(!mPIC.pt)tcu_wprintf(&window7,"YES\n");
	else tcu_wprintf(&window7,"NO\n");
	tcu_wprintf(&window7," Master Clear: ");
	if(mPIC.cp)tcu_wprintf(&window7,"YES\n");
	else tcu_wprintf(&window7,"NO\n");

	tcu_wprintf(&window7,"WatchDogTimer: ");
	if(mPIC.wd)tcu_wprintf(&window7,"YES\n");
	else tcu_wprintf(&window7,"NO\n");
	tcu_wprintf(&window7,"OscillatorTyp: ");
	if(mPIC.osc==0)tcu_wprintf(&window7,"LP\n");
	else if(mPIC.osc==1)tcu_wprintf(&window7,"XT\n");
	else if(mPIC.osc==2)tcu_wprintf(&window7,"iRC\n");
	else if(mPIC.osc==3)tcu_wprintf(&window7,"eRC\n");
}

void Pread(void)			// DW: added void
{
	int i, mask, rdcmd;
	long e=0; long t=aantal/52;
	show_action("reading PIC program area",BLACK);
	write;assert;

	mask = 0x3FFF;

	rdcmd = RDPROG;
	prog_mode();
	for ( i=0; i<aantal; ++i ) {
		command(rdcmd);
		picbuf[i] = pin_word() & mask;
		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	tcu_close_window(&window4);
	mask = 0xFF;

	rdcmd = RDDATA;
	prog_mode();
	show_action("reading PIC data area",BLACK);
	t=DSIZE/52;e=0;
	for ( i=0; i<DSIZE; ++i ) {
		command(rdcmd);
		picbuf[i+0x2100]= pin_word() & mask;

		command(INCADD);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}
	command(LDCONF);
	pout_word(mPIC.fuses);
	for ( i=0; i<7; ++i )
		 command(INCADD);
	command(RDPROG);
	picbuf[0x2007]=pin_word()&0x1F;
	mPIC.fuses=picbuf[0x2007];
	R_fuses();
	tcu_close_window(&window4);
	idle_mode();read;assert;
	strcpy(statbuf,"PicDump");winstat();

}

//------------------------------------
void clock_out(unsigned long  bit)
{
	 bit? adrhi: adrlo;asadres;
	 ms_delay(1);
	 clkhi, asadres;
	 ms_delay(1);
	 clklo, asadres;
	 ms_delay(1);
	 adrlo, asadres;
}

void eclock_out(int bit)			// DW: ANSIfied
{
	 bit? outhi:outlo;asadres;
	 ms_delay(2);
	 adrhi;asadres;
	 ms_delay(2);
	 adrlo; asadres;
	 ms_delay(2);
	 outlo;asadres;
}

void r_adres(long adnr)
{
	unsigned long a,r,adr;
	unsigned long een=1;
	int b;
	adr=(unsigned long)adnr;
	r = 0x80000;
	for ( b=19; b!=0; b-- ){     // used to start at A18-> A0
		r = r>>1;
		a=(adr&r);clock_out(a);
	}

}

int clock_in(void)			// DW: added void
{
	 int b;
	 ms_delay(1);
	 b = inbit? 0: 1;
	 clahi, asadres;
	 ms_delay(1);
	 clalo;asadres;
	 return b;
}

int eclock_in(void)			// DW: added void
{
	 int b;

	 outhi;adrlo; asadres;
	 ms_delay(2);
	 adrhi;asadres;
	 ms_delay(2);
	 b = einbit? 0: 1;
	 ms_delay(2);
	 adrlo;asadres;
	 return b;
}

void out_word(unsigned char w)			// DW: added void
{
	 int b;

	 for ( b=7; b>=0;--b )
		 eclock_out(w&(1<<b));
}

int in_word(void)			// DW: added void
{
	 int b, w;
	 adrhi;asadres;
	 ms_delay(1);
	 clahi;asadres;
	 ms_delay(1);
	 adrlo;asadres;clalo;asadres;

	 for ( w=0, b=7; b>=0; --b)
		 w += clock_in()<<b;
	 return w;
}

int ein_word(void)			// DW: added void
{
	int b, w;

	for ( w=0, b=7; b>=0; --b )
		w += eclock_in()<<b;

	return w;
}

void start(void)			// DW: added void
{
	outlo;asadres;ms_delay(5);
	adrlo;asadres;ms_delay(5);
}

void stop(void)			// DW: added void
{
	adrhi;asadres;ms_delay(5);
	outhi;asadres;ms_delay(5);
}

int strct(void)			// DW: added void
{
	start(),out_word(CTW);
	if(!eclock_in()) return 1;
	else return 0;
}

int strctR(void)			// DW: added void
{
	start(),out_word(CTR);
	if(!eclock_in()) return 1;
	else return 0;
}

int BYTE(unsigned char out)			// DW: ANSIfied
{
	out_word(out);
	if(!eclock_in()) return 1;
	else return 0;
}

void error(void)			// DW: added void
{
	tcu_wprintf(&window4,"error");
	test_hw(1);                 //ARW: maybe hardware not present? check it
	power_down();               //ARW: was powoff
	ppoff;assert;               //ARW duplication also in power_down
	getch();
}
//---------------------------------------------------
//
//---------------------------------------------------

void setup_28C(void)			// DW: added void
{
	setup_timer(0xb0);
	read;assert;
	r_adres_28C(0);
	read,adrlo,pgrhi,ppoff,powoff,clklo,clalo,assert;asadres;
	ms_delay(1000);powon;assert;
	for(int i=0;i<5;i++) ms_delay(30000); //delay 150 mS
}

void setup_28C2(void)			// DW: added void
{
	setup_timer(0xb0);
	read;assert;
	r_adres_28C(0);
	read,adrlo,pgrhi,ppoff,powoff,clklo,clalo,assert;asadres;
	ms_delay(1000);powon;assert;
	ms_delay(30000);
}

void clock_out_28C(unsigned long  bit)
{
	 bit? adrhi: adrlo;asadres;
	 clkhi, asadres;
	 clklo, asadres;
	 adrlo, asadres;
}

int clock_in_28C(void)			// DW: added void
{
	 int b;
	 b = inbit? 0: 1;
	 clahi, asadres;
	 clalo; asadres;
	 return b;
}

int in_word_28C(void)			// DW: added void
{
	 int b, w;
	 adrhi;asadres;
	 clahi;asadres;
	 adrlo;asadres;clalo;asadres;

	 for ( w=0, b=7; b>=0; --b)
		 w += clock_in_28C()<<b;
	 return w;
}

void r_adres_28C(long adnr)
{
	unsigned long a,r,adr;
	int b;
	adr=(unsigned long)adnr;
	r = 0x80000;
	for (b=19; b!=0; b--){	   // DW: used to start at A18->A0
		r=r>>1;
		a=(adr&r);clock_out_28C(a);
	}

}

void show_inout(long i, unsigned char g, unsigned char ch,int twc )
{
      tcu_wprintf(&window2,"address = 0x%lX\n out = 0x%X\n in  = 0x%X\n tWP = %d mS\r ",i,g,ch,twc/1000);
}


void show_action(char *ch,int text_color)
{
	tcu_open_window(&window4, 14,10, 55,3,ch,
		tcu_colour_attrib (WHITE, LIGHTBLUE),
		tcu_colour_attrib (text_color, LIGHTGRAY),
		tcu_colour_attrib (CYAN, BLUE),TCU_BOX_SINGLE);
}

void show_error(unsigned long i,unsigned long st, unsigned char g)
{
	power_down();
	tcu_wprintf(&window4," Error at 0x%lX g = 0x%X buffer = 0x%X",
		    i+st,g,*(rombuf+XMSCurrent(i,0)));
	reset_timer();tcu_warnbeep();setup_timer(0xb0);
	getch();
}

//-------------------------------------------------------
void CRead_28C(void){		//DW: added void

	long e=0,t=aantal/52,i,y,index,index2;

	ClearBuf();				// DW: Made this XMS-aware		memset(rombuf,0,aantal);
	if(st!=0)getoff();

	show_action("Reading Flash chip ");

	setup_28C();
	for(i=0;i<aantal;i++){
		y=i+st;	index = y;
		if (aantal == 0x8000) {
		    index2 = index & 0x4000;
		    index2 = index2 << 1;
		    index  = index | index2;
		}
		r_adres_28C(index);
		rombuf[XMSCurrent(y,1)]=in_word_28C();

		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
		if(rb){if(kbhit()){if(getch()==27) break;}}
	}
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
	grot=aantal;
	tcu_close_window(&window4);
	power_down();
	strcpy(statbuf,"Chip Dump");winstat();
}

//-----------------------------------------------
void verify_28C(void){		//DW: added void

	long e=0, t=aantal/52, i, y,index,index2;
	unsigned char g,q;

	if(st!=0)getoff();
	show_action("Verifying chip");

	setup_28C(); q = 1;
	if(grot>=aantal)grot=aantal-1;
	for(i=0;i<=grot;i++){
		y=i; index = y+st;
		if (aantal == 0x8000) {
		    index2 = index & 0x4000;
		    index2 = index2 << 1;
		    index  = index | index2;
		}
loop_comp:
		r_adres_28C(index);
		g = in_word_28C();
		if( g!=*(rombuf+XMSCurrent(y,0))){		// DW: Made this XMS-aware
		      if(q == 10)
		      {show_error(i,st,g); break; }
		      q++;
		      goto loop_comp;
		}
		if(e==t){ tcu_wprintf(&window4,"");e=0;}
		e++;
		if(rb){	if(kbhit()){ if(getch()==27) break;}}
		q = 1;
	}
	reset_timer();tcu_warnbeep();setup_timer(0xb0);
	tcu_close_window(&window4);
	power_down();/*assert;*/          //ARW: was powoff
}

//-------------------------------------------------------------
void prog_28C(void)			// DW: added void
{
	long e=0, t=aantal/52, i, y, hgrot,index,index2;
	int test,counter,twc = 1000;
	unsigned char g,q,ch,ch2;

	if(st!=0) getoff();
	hgrot=grot;
	tcu_open_window(&window2, 55,17,22,6,NULL,
		tcu_colour_attrib (WHITE, LIGHTBLUE),
		tcu_colour_attrib (RED, LIGHTGRAY),
		tcu_colour_attrib (CYAN, BLUE),TCU_BOX_SINGLE);

	show_action("programming chip");

	setup_28C();
	q = 1;

	Epr.flag_err = OFF;
	tcu_wprintf(&window2,"tWC = %d mS\r ",twc/1000);

	if(grot>=aantal)grot=aantal-1;
	for(i=0;i<=grot;i++){
		y =i; index = y+st;
		if (aantal == 0x8000) {
		    index2 = index & 0x4000;
		    index2 = index2 << 1;
		    index  = index | index2;
		}
rep_28C:
		g=*(rombuf+XMSCurrent(y,0));
		pgrhi;assert;
		read;assert;r_adres_28C(index);
		write;assert;outportb(poort,g);
		pgrlo;assert;ms_delay(2);pgrhi;assert;
		ms_delay(twc);
		read;assert;r_adres_28C(index);
		ch = in_word_28C();

//		show_inout(i,g,ch,twc);
		if(g!=ch){
			if(q==20){
				show_error(i,st,ch);
				Epr.flag_err = ON;
				goto exit_28C;
			}
			else {
				q++;
				twc += 1000;
				if(twc > 15000) twc = 15000;
				tcu_wprintf(&window2,"tWC = %d mS\r ",twc/1000);
				goto rep_28C;
			}
		}

		if(e==t){tcu_wprintf(&window4,"");e=0;	}
		e++; q = 1;
	}
exit_28C:
	tcu_close_window(&window2);
	tcu_close_window(&window4);
	if(!Epr.flag_err) verify_28C();
	power_down();         // ARW: was powoff
}
//------------------------------------------------

void prog_27xx(int m27c)
{		//DW: added void

	long e=0;
	long t=aantal/52;
	long i;long y;	//DW: unused		int er=0;

	unsigned char g,ch;
	int tWP,q=1;

	if(st!=0)getoff();
	tcu_open_window(&window2, 55,17,22,3,NULL,
		tcu_colour_attrib (WHITE, LIGHTBLUE),
		tcu_colour_attrib (BLUE, LIGHTGRAY),
		tcu_colour_attrib (CYAN, BLUE),TCU_BOX_SINGLE);

	show_action("programming chip");

	if (m27c)  {tWP = 150; tcu_wprintf(&window2," tWP = %d uS\r",tWP);}
	else {tWP = 1000; tcu_wprintf(&window2," tWP = %d mS\r",tWP/1000);}

	setup_28C();
	Epr.flag_err = OFF;

	if(grot>=aantal)grot=aantal-1;
	ppon;assert;
	for(i=0;i<=grot;i++){
		y=i;
		g=*(rombuf+XMSCurrent(y,0));
		if(g==0xff)goto SKIP;	// DW: Made this XMS-aware
rep_27:
		pgrhi;ppon;assert;ms_delay(1);
		r_adres_28C(i+st);
		ppon;assert;ms_delay(20);
			write;assert;outportb(poort,g);
		ms_delay(10);
			pgrlo;assert;ms_delay(tWP);
			pgrhi;assert;
		ms_delay(10);
		adrlo;clklo;clalo;asadres;ms_delay(5);
		if(!epr64){ ppoff;assert; }
		read;assert;
		if(!epr64){ pgrlo;assert; }
		ms_delay(10);
		ch = in_word_28C();
		if(g!=ch){
			if(q==25){
				show_error(i,st,ch);
				Epr.flag_err = ON;
				goto PE;
			}
			else{
				q++;
				if(m27c) {
				      tWP += 100;
				      tcu_wprintf(&window2," tWP = %d uS\r ",tWP);
				}
				else {
				      tWP += 1000;
				      tcu_wprintf(&window2," tWP = %d mS\r ",tWP/1000);
				}
				goto rep_27;
			}
		}
SKIP:
		if(m27c) tWP = 120; else tWP = 1000;
		if(e==t){ tcu_wprintf(&window4,"");e=0;}
		e++;
		q=1;

	}
PE:	ppoff; assert;		//DW: added. Used to leave program power on!
	tcu_close_window(&window4);
	tcu_close_window(&window2);
	if(!Epr.flag_err) Compare();
	power_down();
}


//--------------------------------------------------------
void prog_f28(void)			// DW: added void
{
	long e=0, t=aantal/52, i, y, hgrot;
	unsigned char g;
	int q=1;
	if(st!=0) getoff();
	hgrot=grot;
	if(erase) grot=aantal;
	if(erase)
	     show_action("programming chip zero");
	else show_action("programming chip");


	setup_28C();

	pgrhi;assert;
	r_adres(0);
	ppon;assert;
	if(grot>=aantal) grot=aantal-1;
	for(i=0;i<=grot;i++){
		y=i;
		if(erase) g=0;
		else g=*(rombuf+XMSCurrent(y,0));		// DW: Made this XMS-aware
r:
		pgrhi;assert;
		r_adres(i+st);
		write;assert;
		ms_delay(5);
		outportb(poort,0x40);

		ms_delay(100);
		pgrlo;assert;ms_delay(TICKS(6));pgrhi;assert;

		ms_delay(1);
		outportb(poort,g);
		pgrlo;assert;ms_delay(TICKS(6));pgrhi;assert;
		ms_delay(10);
		outportb(poort,0xC0);
		ms_delay(5);
		pgrlo;assert;ms_delay(TICKS(6));pgrhi;assert;
		ms_delay(TICKS(6));
		adrlo;clklo;clalo;asadres;
		ms_delay(5);
		read;assert;
		ms_delay(5);
		if(g!=(unsigned char)in_word()){
			if(q==20){
				power_down();
				tcu_wprintf(&window4,"error");
				reset_timer();tcu_warnbeep();setup_timer(0xb0);
				ppoff;assert;     //ARW: duplication
				getch();
				goto P8E;
			}
			else {g++; goto r;}
		}
		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
		q=1;
	}
	ppoff;assert;
	tcu_close_window(&window4);
	grot=hgrot;
	if(erase)return;
	show_action("verifying chip",GREEN);

	for(i=0;i<=grot;i++){

		y=i;

		r_adres(i+st);
		if(in_word()!=*(rombuf+XMSCurrent(y,0))) {		// DW: Made this XMS-aware
			power_down();
			tcu_wprintf(&window4,"Error at 0x%lX",i+st);		// DW: added offset
			reset_timer();tcu_warnbeep();setup_timer(0xb0);
			/*assert*/;getch();
			break;
		}
		if(e==t){ tcu_wprintf(&window4,""); e=0;}
		e++;
	}
P8E:	tcu_close_window(&window4);
	power_down();/*assert;*/ 			//ARW: was powoff
}

//-----------------------------------
void prog_f29(void)			// DW: added void
{
	long e=0, t=aantal/52, i, y, hgrot;
	int test;
	unsigned char g;
	if(st!=0) getoff();
	hgrot=grot;

	show_action("programming chip");
	setup_28C();

	if(grot>=aantal)grot=aantal-1;
	for(i=0;i<=grot;i++){
		y=i;

		g=*(rombuf+XMSCurrent(y,0));
		pgrhi;assert;
		read;assert;

		r_adres(0x5555);
		write;assert;ms_delay(2);outportb(poort,0xaa);
		ms_delay(zes);
		pgrlo;assert;ms_delay(1);pgrhi;assert;
		read;assert; ms_delay(2);r_adres(0x2AAA);
		write;assert;ms_delay(2);outportb(poort,0x55);
		pgrlo;assert;ms_delay(1);pgrhi;assert;
		read;assert; ms_delay(2);r_adres(0x5555);
		write;assert;ms_delay(2);outportb(poort,0xa0);
		ms_delay(2);
		pgrlo;assert;ms_delay(1);pgrhi;assert;
		read;assert; ms_delay(2);r_adres(i+st);
		write;assert;outportb(poort,g);ms_delay(2);
		pgrlo;assert;ms_delay(1);pgrhi;assert;
		ms_delay(2);
		adrlo;clklo;clalo;asadres;
		read;assert;ms_delay(2);

		test=in_word();
		while(test!=g) {
			if(getch()==27) {
				tcu_wprintf(&window4,"            program interrupted!");getch();
				tcu_close_window(&window4);idle_mode();return;
			}
			ms_delay(1);test=in_word();
		}

		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;

	}

	tcu_close_window(&window4);
	grot=hgrot;

	show_action("verifying chip");
	for(i=0;i<=grot;i++){
		y=i;
		r_adres(i+st);
		if(in_word()!=*(rombuf+XMSCurrent(y,0))) {
			tcu_wprintf(&window4,"Error at 0x%lX",i+st);
			reset_timer();tcu_warnbeep(); setup_timer(0xb0);
			power_down();getch();
			break;
		}
		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
	}
	tcu_close_window(&window4);
	power_down();/*assert; */           //ARW: was powoff
}

//-----------------------------------------------

void erase_f28(void){			// DW: added void
	long e=0, t=aantal/52, i=0;

	int q=1;
	if(st!=0) getoff();

	erase=1;
	if(!qe)prog_f28();
	show_action("erasing chip");
	setup();
	pgrhi;assert;
	r_adres(0);
	ppon;assert;

F:	pgrhi;assert;

	write;assert;ms_delay(5);outportb(poort,0x20);

	ms_delay(5);
	pgrlo;assert;ms_delay(TICKS(6));pgrhi;assert;

	ms_delay(1);
	outportb(poort,0x20);
	pgrlo;assert;ms_delay(TICKS(6));pgrhi;assert;
	ms_delay(10000);

	do{
		outportb(poort,0xA0);
		ms_delay(5);
		pgrlo;assert;ms_delay(TICKS(6));pgrhi;assert;
		ms_delay(TICKS(6));
		adrlo;clklo;clalo;asadres;
		ms_delay(5);
		read;assert;
		ms_delay(5);
		if(in_word()!=0xff){
			if(q==1000){
				tcu_wprintf(&window4,"error");
				reset_timer();tcu_warnbeep();setup_timer(0xb0);
				ppoff;
				power_down();/*assert;*/         //ARW: was powoff
				getch();
				break;
			}
			else {
				q++;
				goto F;
			}
		}
		if(qe)i=i+20;
		else i++;
		r_adres(i+st);
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		if(qe)e=e+20;
		else e++;
	} while(i<=aantal);

	power_down();                  //ARW was powoff
	ppoff;assert;                  //ARW: duplication
	erase=0;
	tcu_close_window(&window4);
}


void erase_f29(void){           // DW: added void

	int test;

	if(st!=0)getoff();

	show_action("erasing chip");

	setup_28C();

	read;assert;
	r_adres(0x5555);
	write;assert;ms_delay(1);outportb(poort,0xAA);
	ms_delay(1);
	pgrlo;assert;ms_delay(1);pgrhi;assert;
	ms_delay(1);
	read;assert; ms_delay(1);r_adres(0x2AAA);
	write;assert;ms_delay(5);outportb(poort,0x55);
	pgrlo;assert;ms_delay(5);pgrhi;assert;
	ms_delay(5);
	read;assert; ms_delay(5);r_adres(0x5555);
	ms_delay(5);
	write;assert;outportb(poort,0x80);
	ms_delay(5);
	pgrlo;assert;ms_delay(5);pgrhi;assert;
	ms_delay(5);
	outportb(poort,0xAA);
	ms_delay(5);
	pgrlo;assert;ms_delay(5);pgrhi;assert;
	ms_delay(5);
	read;assert; ms_delay(5);r_adres(0x2AAA);
	write;assert;ms_delay(5);outportb(poort,0x55);
	pgrlo;assert;ms_delay(5);pgrhi;assert;
	ms_delay(5);
	read;assert; ms_delay(5);r_adres(0x5555);
	write;assert;ms_delay(5);outportb(poort,0x10);
	pgrlo;assert;ms_delay(5);pgrhi;assert;
	ms_delay(12000);
	adrlo;clklo;clalo;asadres;assert;
	read;assert;
	ms_delay(105);
	test=0;

	while((test!= 0xFF)){
		if(kbhit()){
			if(getch()==27){
				tcu_wprintf(&window4,"            erase interrupted!");getch();
				tcu_close_window(&window4);
				idle_mode(); return;
			}
		}
	test=in_word();
	}
k:
	tcu_wprintf(&window4,"     erase completed");getch();
	power_down();/*assert;*/        //ARW: was powoff
	tcu_close_window(&window4);
	idle_mode();   //ARW: duplication
}

void eprogram65(void)
{
	unsigned char adrby1, adrby2;
	unsigned int e=0, t=aantal/52, i;

	int w=0;
	unsigned char g,k;
	show_action("programming chip");

	outhi,adrhi;asadres;
	if(pin7)pgrhi;
	else pgrlo;
	assert;
	write;assert;
	powon;assert;

	ms_delay(30000);
	for(i=0;i<grot;i++){

		g=*(rombuf+XMSCurrent(i,0));		// DW: Made this XMS-aware

		adrby1=i>>8;
		adrby2=i;

		if(strct()) {
			if(BYTE(adrby1)){
				if(BYTE(adrby2)){
					if(BYTE(g)){
						outlo;asadres;stop();
					}
					else {
						error();
						break;
					}
				}
			}
			else {
				error();
				break;
			}
		}
		else {
			error();
			break;
		}
		W:
		if(strct()){
			if(BYTE(adrby1)){
				if(BYTE(adrby2)){
					start();
					stop();
					if(strctR()){
						k=ein_word();eclock_out(1);stop();
					}
					else {
						error();
						break;
					}
				}
				else {
					error();
					break;
				}
			}
			else {
				error();
				break;
			}
		}
		else {
			ms_delay(TICKS(1000));
			w++;
			if(w==10){
				error();break;
			}
			stop();
			goto W;
		}
		if(k!=g){
			error();
			break;
		}
		w=0;
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
	}

	tcu_close_window(&window4);
	power_down();		//ARW: replaces powoff
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
	//powoff,
	read;assert;      //duplication but left for clarity
}

void prog_16(void){			// DW: added void
	unsigned char adrby1, adrby2;
	unsigned int e=0, t=aantal/52, i;
	int w=0;    //DW: unused c=0,
	int g,k;

	write;assert;
	show_action("programming chip");

	outhi,adrhi;asadres;
	if(pin7)pgrhi;
	else pgrlo;assert;
	powon;assert;
	ms_delay(30000);
	for(i=0;i<grot;i++){
		g=*(rombuf+XMSCurrent(i,0));		// DW: Made this XMS-aware

		adrby1=0;
		adrby1=i>>7;
		adrby1&=126;
		adrby1=adrby1+CTW;
		adrby2=i;

		start();

		if(BYTE(adrby1)){
			if(BYTE(adrby2)){
				if(BYTE(g)){
					outlo;asadres;stop();ms_delay(TICKS(1000));
				}
				else {error();break;}
			}
		}
		else { error();	break;}
W:
		start();
		if(BYTE(adrby1)){
			if(BYTE(adrby2)){
				start();
				stop();
				adrby1=adrby1+1;
				start();
				if(BYTE(adrby1)){
					k=ein_word();
					eclock_out(1);
					stop();
				} else {error();break;}
			}else {error();	break;}
		}
		else {
			ms_delay(TICKS(1000));
			w++;
			if(w==10){error();break;}
			stop();
			goto W;
		}
		if(k!=g){error();break;	}
		w=1;

		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
	}
	tcu_close_window(&window4);
	power_down();
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);

	read;assert; 		//ARW: duplication but left for clarity

}

void read_16(void){		//DW: added void
	unsigned char adrby1, adrby2;
	unsigned int e=0, t=aantal/52, i;


	unsigned char g;

	write;assert;
	show_action("reading chip",BLACK);

	outhi,adrhi;asadres;
	if(pin7)pgrhi;
	else pgrlo;assert;
	powon;assert;
	ms_delay(15000);
	for(i=0;i<aantal;i++){
		adrby1=0;
		adrby1=i>>7;
		adrby1&=126;
		adrby1=adrby1+CTW;
		adrby2=i;

		start();
		if(BYTE(adrby1)){
			if(BYTE(adrby2)){
				start();
				stop();
				adrby1=adrby1+1;
				start();
				if(BYTE(adrby1)){
					g=ein_word();clock_out(1);stop();
				}
				else {
					error();
					break;
				}
			}
			else {
				error();
				break;
			}
		}
		else {
			error();
			break;
		}
		rombuf[XMSCurrent(i,1)]=g;		// DW: Made this XMS-aware
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
		if(rb){
			if(kbhit()){
				if(getch()==27) break;
			}
		}
	}

	tcu_close_window(&window4);
	power_down();
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);

	read,assert;      //ARW: duplication but left for clarity
	 grot=aantal;
	strcpy(statbuf,"Chip dump");winstat();
}

void verify_16(void)		//DW: added void
{
	unsigned char adrby1, adrby2;
	unsigned int e=0, t=aantal/52, i;
	unsigned char g;

	show_action("comparing chip",GREEN);

	outhi,adrhi;asadres;
	if(pin7)pgrhi;
	else pgrlo;assert;
	powon;assert;

	write;assert;
	ms_delay(15000);
	for(i=0;i<grot;i++){
		adrby1=0;
		adrby1=i>>7;
		adrby1&=126;
		adrby1=adrby1+CTW;
		adrby2=i;

		start();
		if(BYTE(adrby1)){
			if(BYTE(adrby2)){
				start();
				stop();
				adrby1=adrby1+1;
				start();
				if(BYTE(adrby1)) {
					g=ein_word();
					eclock_out(1);
					stop();
				}
				else {
					error();
					break;
				}
			}
			else {
				error();
				break;
			}
		}
		else {
			error();
			break;
		}
		if(g!=rombuf[XMSCurrent(i,0)]){		// DW: Made this XMS-aware
			error();
			break;
		}
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;
		if(rb){
			if(kbhit()){
				if(getch()==27) break;
			}
		}
	}
	tcu_close_window(&window4);
	idle_mode();
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);

	grot=aantal;
}

void read_65(void){		//DW: added void
	unsigned char adrby1, adrby2;
	unsigned int e=0, t=aantal/52, i;
	unsigned char g;

	write;assert;
	show_action("reading chip",BLACK);

	outhi,adrhi;asadres;
	if(pin7)pgrhi;
	else pgrlo;assert;

	powon;assert;
	ms_delay(15000);
	for(i=0;i<=aantal;i++){
		adrby1=i>>8;
		adrby2=i;

		if(strct()){
			if(BYTE(adrby1)){
				if(BYTE(adrby2)){
					start();
					stop();
					if(strctR()){
						g=ein_word();eclock_out(1);stop();
					}
					else {        // DW: removed some unused code
						error();
						break;
					}
				}
				else {
					error();
					break;
				}
			}
			else {
				error();
				break;
			}
		}
		else {
			error();
			break;
		}
		rombuf[XMSCurrent(i,1)]=g;		// DW: Made this XMS-aware
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;

		if(rb){
			if(kbhit()){
				if(getch()==27) break;
			}
		}
	}

	tcu_close_window(&window4);
	power_down();              //ARW:
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);

	//powoff,
	read,assert;               //ARW:    duplication

	grot=aantal;
	strcpy(statbuf,"Chip dump");winstat();
}

void verify_65(void){		//DW: added void
	unsigned char adrby1, adrby2;
	unsigned int e=0, t=aantal/52, i;
	unsigned char g;

	show_action("comparing chip",GREEN);

	outhi,adrhi;asadres;
	if(pin7)pgrhi;
	else pgrlo;assert;
	powon;assert; write;assert;
	ms_delay(15000);
	for(i=0;i<grot;i++){
		adrby1=i>>8;
		adrby2=i;

		if(strct()){
			if(BYTE(adrby1)){
				if(BYTE(adrby2)){
					start();
					stop();
					if(strctR()){
						g=ein_word();eclock_out(1);stop();
					}
					else {		//DW: clean up a bit
						error();
						break;
					}
				}
				else {
					error();
					break;
				}
			}
			else {
				error();
				break;
			}
		}
		else {
			error();
			break;
		}
		if(g!=rombuf[XMSCurrent(i,0)]){		// DW: Made this XMS-aware
			error();
			break;
		}
		if(e==t){
			tcu_wprintf(&window4,"");
			e=0;
		}
		e++;

		if(rb){
			if(kbhit()){
				if(getch()==27)break;
			}
		}
	}
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);

	tcu_close_window(&window4);
	idle_mode();
	grot=aantal;
}

int test_hw(int dont_stop){		//DW: added void //ARW: added parameter
					//so we can check hardware present before each
					//operation
	int l,r;
	setup_28C2();

	pgrhi;assert;write;assert;
	outhi;asadres;ms_delay(1000);
	r=einbit;
	outlo;asadres;ms_delay(1000);
	l=einbit;

	if(l==0x80&&r==0x00){
		power_down();
		if(!dont_stop){
			tcu_open_window(&window2, 12,13, 37,6,NULL,
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),TCU_BOX_SINGLE);
			tcu_wprintf(&window2,"\n     Hardware present ");
			getch();
			tcu_close_window(&window2);

		}                     //ARW: added
		hardware_er = 0;
	}
	else{
		power_down();
		tcu_open_window(&window2, 12,13, 37,6,NULL,
			tcu_colour_attrib (WHITE, LIGHTBLUE),
			tcu_colour_attrib (RED, LIGHTGRAY),
			tcu_colour_attrib (CYAN, BLUE),TCU_BOX_SINGLE);
		reset_timer();tcu_warnbeep();setup_timer(0xb0);
		tcu_wprintf(&window2,"\n hardware error :  Check Power and\n connections");getch();
		hardware_er = 1;
		tcu_close_window(&window2);
	}
	power_down();      //ARW: was powoff
	read;assert;       //ARW: duplication
	return(hardware_er);
	 //ditto
}

//DW: added
void ClearBuf(void) {
	long l=aantal;
	while( l>0 ) {
		XMSCurrent( (l-1)/sizeof(rombuf)*sizeof(rombuf), 1 );
		memset( rombuf, 0, sizeof(rombuf) );     //ARW "suspicious pointer conversion"
		l -= sizeof(rombuf);
	}
}

void CRead(void){		//DW: added void
	//DW: unused		unsigned char *hbuf;
	long e=0;long t=aantal/52; long i;long y;
	ClearBuf();				// DW: Made this XMS-aware		memset(rombuf,0,aantal);
	if(st!=0)getoff();

	show_action("reading chip",BLACK);
	setup();
	if(epr64){
		pgrhi;assert;
	}
	r_adres(0);
	for(i=0;i<aantal;i++){
		y=i+st;

		r_adres_28C(i+st);
		rombuf[XMSCurrent(y,1)]=in_word_28C();
		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
		if(rb){
			if(kbhit()){
				if(getch()==27) break;
			}
		}
	}
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
	grot=aantal;
	tcu_close_window(&window4);
	power_down();/* */assert;          //ARW: was powoff , assert;

	strcpy(statbuf,"Chip Dump");winstat();
}

void Program8751(void)
{		//DW: added void  //ARW: added new proc
	long e=0; long t=aantal/52; long i;long y;	//DW: unused		int er=0;

	unsigned char g;
	int q=1,q0=0;   //ARW: added q0
	//if(!ep) fast=1;	//ARW: added change default normal to fast
	if(st!=0)getoff();
	show_action("programming chip");

	setup();

	pgrhi;assert;
	r_adres(0);
	if(grot>=aantal)grot=aantal-1;
	for(i=0;i<=grot;i++){
		y=i;

		g=*(rombuf+XMSCurrent(y,0));	 // DW: Made this XMS-aware
	//	if(g==0xFF)goto skip_burn ;      //ARW: added, dont bother to program it
													// but will verify later
		r:
		pgrhi;assert;
		r_adres(i+st);
		write;assert;
		ms_delay(15);               //ARW: OE to Vpp delay increased for 8751
		outportb(poort,g);
		ms_delay(15);	            //ARW: added allow bus to settle
		if(!pe){
			ppon;assert;
		}
		ms_delay(150);
		pgrlo;assert;
		if(pe){
			ms_delay(TICKS(1000));
			pgrhi;assert;
		}
		else{ if(ep) {
			ms_delay(119);       //ARW: express , delay 100usecs (snap mode)
			pgrhi;assert;
			ms_delay(15);        //ARW: delay at least 10usecs between pgm pulses
			pgrlo;assert;        //ARW: do another pulse now it saves a lot of time
			ms_delay(119);       //ARW: max downside is one pulse too many
			q++;	             //ARW: upside is nearly halved program time
		     }                	     //ARW: inc pulse acc we did an extra pulse here
		     else if(!fast)delay(burn);   //ARW normal but must not exceed 50ms total
		     else if(q<burn)arw_delay((long)((q-q0)*1200)); //ARW fast intelligent 1ms pulse
		     else arw_delay((long)((burn-q0)*1200));	//doubles every time till done
					     //q is acc burn time after this pulse
		}
		pgrhi;assert;

		if(pe) ms_delay(TICKS(1000));
		else ms_delay(150);
		adrlo;clklo;clalo;asadres;
		ms_delay(5);
		if((!epr64)||e8751){               //ARW need Vpp at 5v for reading 8751
			ppoff;assert;
		}
		read;assert;
		ms_delay(5);
		if(!epr64&&!e8751){             //ARW: need pgrhi for 8751 read
			pgrlo;assert;                //ARW: not sure about this for 2732/2716
		}
		ms_delay(150);
		if(g!=(unsigned char)in_word()){
			if(q>=burn||(!ep&&!fast)){     //ARW: changed to GE
				//gives user some control
				//now burn means max no of  .1 or 1ms pulses
				//depending on mode express/fast
				//ARW: also if normal must only do one
				//pulse or will really burn it!!!!
				tcu_wprintf(&window4,"Error at 0x%lX",i+st);	// DW: added offset
				reset_timer();tcu_warnbeep();setup_timer(0xb0);
				ppoff;assert;
				power_down();			//ARW: was powoff before assert
				getch();
				goto PE;
			}
			else{
				if(!fast)        //ARW:
				  {q++;
					goto r;
				  }
				  else                //ARW: must be fast intelligent mode
				  { q0=q;              //save last q to calculate new delay
				    q=2*q;	      //ARW: q= accumulated burn time in msecs
				  //q=int(q*3/2)+1;   // this algorithm can be changed as requ
				  //q++;
				    goto r;
				  }
			}
		}
skip_burn:
		//if(epr64){if(er<200){er++;goto r;}}
		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
		q=1;

	}
	ppoff; assert;		//DW: added. Used to leave program power on!
	tcu_close_window(&window4);
	show_action("verifying chip",GREEN);

	for(i=0;i<=grot;i++){

		y=i;

		r_adres(i+st);
		if(in_word()!=*(rombuf+XMSCurrent(y,0))){		// DW: Made this XMS-aware
			tcu_wprintf(&window4,"Error at 0x%lX",i+st);	// DW: added offset
			power_down();/*assert;*/			//ARW: was powoff
			reset_timer();tcu_warnbeep();setup_timer(0xb0);getch();
			goto PE;
		}
		if(e==t){
			tcu_wprintf(&window4,"");e=0;
		}
		e++;   }
	//ARW: now in power_down()
PE:                             //ARW jump to here avoids reset_timer???
	tcu_close_window(&window4);
	power_down();
	//powoff;assert;               //ARW: now part of power_down()
}

void Check(void){		//DW: added void
	long e=0, t=aantal/52, i;
	unsigned char h;	//DW: unused		q=1;

	if(PIC)return;
	if(st!=0)getoff();
	show_action("CheckEmpty chip");
	setup();
	if(epr64){ pgrhi;assert; }
	for(i=0;i<aantal;i++){
rep_check:
		r_adres_28C(i+st);
		h=in_word_28C();
		if(h!=0xff){
			power_down();
			tcu_wprintf(&window4,"Error at 0x%lX",i+st);		// DW: added offset
			reset_timer();tcu_warnbeep();
			setup_timer(0xb0);getch();
			break;
		}
		if(e==t){tcu_wprintf(&window4,"");e=0;}
		e++;
		if(rb){if(kbhit()){if(getch()==27) break;}}
	}
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
	tcu_close_window(&window4);
	power_down();/*assert;*/               //ARW: was powoff
}

void Compare(void)
{		//DW: added void
	long e=0, t=aantal/52, i, y;
	unsigned char g,q;

	if(st!=0)getoff();
	show_action("comparing chip",BLUE);
	setup();
	ms_delay(30000);
	q = 0;
	if(epr64){pgrhi;assert;}
	if(grot>=aantal)grot=aantal-1;
	read;assert;ms_delay(5);
	for(i=0;i<=grot;i++){
		y=i;
loop_comp:
		r_adres_28C(i+st);
		g = in_word_28C();
		if( g!=*(rombuf+XMSCurrent(y,0))){		// DW: Made this XMS-aware
		      if(q == 10){ show_error(i,st,g); break; }
		      q++;
		      goto loop_comp;
		}
		if(e==t){ tcu_wprintf(&window4,"");e=0;}
		e++;
		if(rb){	if(kbhit()){ if(getch()==27) break;}}
		q = 1;
	}
	reset_timer(); tcu_warnbeep(); setup_timer(0xb0);
	tcu_close_window(&window4);
	power_down();/*assert;*/          //ARW: was powoff
}

unsigned Process_Line (unsigned char *inp_line) {

	int file_chksum, calc_chksum;

	unsigned i, status;
	unsigned count, type;
	long  address, addhi, addlo;
	unsigned char  *inp_ptr;		//DW: unused		 *out_ptr;
	inp_line=strstr(inp_line, ":") ; //ARW: reset inp_line to point to colon
	if ( inp_line != NULL) {          //ARW: avoids errors due to LFCR / CRLF
										//ARW: warning now accepts bytes before the colon
		sscanf(inp_line, ":%2X%2lX%2lX%2X", &count, &addhi, &addlo, &type);
		calc_chksum = count + addhi + addlo + type;
		inp_ptr = inp_line + 9;
		for (i=0; i<count; i++) {
			sscanf(inp_ptr, "%2X", &bytes[i]);
			calc_chksum += bytes[i];
			inp_ptr +=2;
		}
		calc_chksum =-(calc_chksum & 0xFF) & 0xFF;

		sscanf(inp_ptr, "%2X", &file_chksum);

		if (calc_chksum == file_chksum) {
			address = (addhi << 8) + addlo;
			address=address;

			for (i=0; i<count; i++)
				*(rombuf+XMSCurrent(address+i,1))= bytes[i];
			image_highwater=MAX(image_highwater,address+i);
			status = 1;
		}
		else {
			tcu_open_window(&window6, 17,3, 40,3,
					"ERROR",
					tcu_colour_attrib (WHITE, LIGHTBLUE),
					tcu_colour_attrib (RED, LIGHTGRAY),
					tcu_colour_attrib (CYAN, BLUE),
					TCU_BOX_SINGLE);

			tcu_clear_window(&window6);
			tcu_wprintf(&window6," Checksum Error reading Hexfile");
			getch();
			tcu_close_window(&window6);status=0;
		}
	}
	else {
		tcu_open_window(&window6, 17,3, 30,3,
				"ERROR",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

		tcu_clear_window(&window6);
		tcu_wprintf(&window6," Error reading Hexfile");
		getch();
		tcu_close_window(&window6);status=0;
	}
	return status;
}

unsigned Process_LineS1 (unsigned char *inp_line) {

	int      file_chksum, calc_chksum;

	unsigned i, status;
	unsigned count;							//DW: unused		type;
	unsigned  address, addhi;		//DW: unused		addlo;
	unsigned char  *inp_ptr;		//DW: unused		 *out_ptr;

	if (strstr(inp_line, "S1") != NULL) {
		inp_ptr=inp_line+2;

		sscanf(inp_line, "S1%2X%4X%", &count, &addhi);
		calc_chksum = count + (addhi & 0xFF) + ((addhi >> 8) & 0xFF);
		count=count-3;

		inp_ptr = inp_line + 8;

		for (i=0; i<count; i++) {
			sscanf(inp_ptr, "%2X", &bytes[i]);
			calc_chksum += bytes[i];
			inp_ptr +=2;
		}
		calc_chksum =~calc_chksum & 0xFF;

		sscanf(inp_ptr, "%2X", &file_chksum);

		if (calc_chksum == file_chksum) {
			address = addhi;
			address=address;

			for (i=0; i<count; i++)
				*(rombuf+XMSCurrent(address+i,1))= bytes[i];		// DW: Made this XMS-aware
			image_highwater=MAX(image_highwater,address+i);
			status = 1;
		}
		else {
			tcu_open_window(&window6, 17,3, 40,3,
				"ERROR",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

			tcu_clear_window(&window6);
			tcu_wprintf(&window6," Checksum Error reading Hexfile");
			getch();
			tcu_close_window(&window6);status=0;
		}
	}
	else { /*
		tcu_open_window(&window6, 17,3, 30,3,
				"ERROR",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

		tcu_clear_window(&window6);
		tcu_wprintf(&window6," Error reading Hexfile");
		getch();
		tcu_close_window(&window6);*/status=1;
	}
	return status;
}

unsigned Process_LineS3 (unsigned char *inp_line) {

	unsigned      file_chksum, calc_chksum;

	unsigned i, status;
	unsigned count;							//DW: unused		type;
	unsigned  address, addhi;		//DW: unused		addlo;
	unsigned char  *inp_ptr;		//DW: unused		*out_ptr;

	if (strstr(inp_line, "S3") != NULL) {
		inp_ptr=inp_line+2;

		sscanf(inp_line, "S3%2X%8X%", &count, &addhi);

		calc_chksum = count + (addhi & 0xFF) + ((addhi >> 8) & 0xFF);
		count=count-5;

		inp_ptr = inp_line + 12;

		for (i=0; i<count; i++) {
			sscanf(inp_ptr, "%2X", &bytes[i]);
			calc_chksum += bytes[i];
			inp_ptr +=2;
		}
		calc_chksum =~calc_chksum;
		calc_chksum=calc_chksum & 0xFF;
		sscanf(inp_ptr, "%2X", &file_chksum);

		if (calc_chksum == file_chksum) {
			address = addhi;


			for (i=0; i<count; i++)
				*(rombuf+XMSCurrent(address+i,1))= bytes[i];		// DW: Made this XMS-aware
			image_highwater=MAX(image_highwater,address+i);
			status = 1;
		}
		else {
			tcu_open_window(&window6, 17,3, 40,3,
				"ERROR",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

			tcu_clear_window(&window6);
			tcu_wprintf(&window6," Checksum Error reading Hexfile");
			getch();
			tcu_close_window(&window6);status=0;
		}
	}
	else { /*
		tcu_open_window(&window6, 17,3, 30,3,
				"ERROR",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

		tcu_clear_window(&window6);
		tcu_wprintf(&window6," Error reading Hexfile");
		getch();
		tcu_close_window(&window6);*/status=1;
	}
	return status;
}

unsigned Pic_Line (unsigned char *inp_line) {

	int      file_chksum, calc_chksum;

	unsigned i, w,status;
	unsigned count, type;
	long  address, addhi, addlo;
	unsigned char  *inp_ptr;		//DW: unused		*out_ptr;

	if (strstr(inp_line, ":") != NULL) {
		sscanf(inp_line, ":%2X%2lX%2lX%2X", &count, &addhi, &addlo, &type);
		calc_chksum = count + addhi + addlo + type;
		inp_ptr = inp_line + 9;
		for (i=0; i<count; i++) {
			sscanf(inp_ptr, "%2X", &bytes[i]);
			calc_chksum += bytes[i];
			inp_ptr +=2;
		}
		calc_chksum =-(calc_chksum & 0xFF) & 0xFF;

		sscanf(inp_ptr, "%2X", &file_chksum);
		sscanf(inp_line, ":%2X%2lX%2lX%2X", &count, &addhi, &addlo, &type);

		count=count/2;
		inp_ptr = inp_line + 9;
		for (i=0; i<count;i++) {
			sscanf(inp_ptr, "%4X", &w);
			w=(((w)>>8)+(((w)&0xFF)<<8));

			inp_ptr +=4;
			bytes[i]=w;
		}

		if (file_chksum==calc_chksum) {
			address = (addhi << 8) + addlo;
			address=address/2;

			for (i=0; i<count; i++)
				*(picbuf+address+i)= bytes[i];              //ARW: types mixed
			image_highwater=MAX(image_highwater,address+i);
			status = 1;
		}
		else {
			tcu_open_window(&window6, 17,3, 40,3,
					"ERROR",
					tcu_colour_attrib (WHITE, LIGHTBLUE),
					tcu_colour_attrib (RED, LIGHTGRAY),
					tcu_colour_attrib (CYAN, BLUE),
					TCU_BOX_SINGLE);

			tcu_clear_window(&window6);
			tcu_wprintf(&window6," Checksum Error reading Hexfile");
			getch();
			tcu_close_window(&window6);status=0;
		}
	}
	else {
		tcu_open_window(&window6, 17,3, 30,3,
				"ERROR",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (RED, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

		tcu_clear_window(&window6);
		tcu_wprintf(&window6," Error reading Hexfile");
		getch();
		tcu_close_window(&window6);status=0;
	}
	return status;
}

void testmenu(void){		//DW: added void
	int c=0;int i=0;int status=1;
	struct ffblk fileinfo;
	if(hexl){
		if(findfirst("*.hex",&fileinfo,0)!=-1){
			strcpy(filen[c],fileinfo.ff_name);
			while(findnext(&fileinfo)==0){
				c++;
				strcpy(filen[c],fileinfo.ff_name);
			}
		}
		c++;
		filen[c]=NULL;

		tcu_define_menu (&test,
			 "hex files",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 filen,
			 0);
		hexl=0;
	}
	tcu_display_menu(&test,22,4);
	i=tcu_read_menu_selection (&test);
	tcu_remove_menu (&test);
	if(i>0)fp=fopen(filen[i-1],"r");
	else return;
	if(fp==NULL)return;
	ClearBuf();		// DW: Made this XMS-aware			memset (rombuf, 0, aantal);
	while ((fgets(inp_line,80,fp) != NULL) && (status))
		 if(PIC)status =Pic_Line(inp_line);else status=Process_Line (inp_line);
	fclose(fp);
	if(status){
		grot=image_highwater;
		image_highwater=0;		//DW: removed some extra {}'s after this line
		strcpy(statbuf,filen[i-1]);winstat();
		if(PIC){
			mPIC.fuses=picbuf[0x2007];
			if(C50)R_50fuses();
			else R_fuses();
		}
	}
}

void S3_load(void){		//DW: added void
	int c=0;int i=0;int status=1;
	struct ffblk fileinfo;
	if(hexl){
		if(findfirst("*.hex",&fileinfo,0)!=-1){
			strcpy(filen[c],fileinfo.ff_name);
			while(findnext(&fileinfo)==0){
				c++;
				strcpy(filen[c],fileinfo.ff_name);
			}
		}
		c++;
		filen[c]=NULL;

		tcu_define_menu (&test,
			 "hex files S3",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 filen,
			 0);
		hexl=0;
	}
	tcu_display_menu(&test,22,4);
	i=tcu_read_menu_selection (&test);
	tcu_remove_menu (&test);
	if(i>0)fp=fopen(filen[i-1],"r");
	else return;
	if(fp==NULL)return;
	ClearBuf();		// DW: Made this XMS-aware			memset (rombuf, 0, aantal);
	while ((fgets(inp_line,80,fp) != NULL) && (status))
		if(S3)status=Process_LineS3(inp_line);
		else status=Process_LineS1(inp_line);
	fclose(fp);
	if(status){
		grot=image_highwater;image_highwater=0;{
			strcpy(statbuf,filen[i-1]);winstat();
		}
	}
}

void load_file(void){ }		//DW: added void


void load_bin(void){		//DW: added void
	static int c=0;int i=0;struct ffblk fileinfo;     //DW: unused		int j; long gr=0

	grot=0;

	if(binl){
		if(findfirst("*.bin",&fileinfo,0)!=-1){
			strcpy(filbin[c],fileinfo.ff_name);
			while(findnext(&fileinfo)==0){
				c++;
				strcpy(filbin[c],fileinfo.ff_name);
			}
		}
		c++;filbin[c]=NULL;binl=0;
		tcu_define_menu (&bin,
			 "bin files",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 filbin,
			 0);
	}
	tcu_display_menu(&bin,22,3);
	i=tcu_read_menu_selection (&bin);
	tcu_remove_menu (&bin);
	if(i>0)fp=fopen(filbin[i-1],"rb");
	else return;
	if(fp==NULL)return;
	ClearBuf();		// DW: Made this XMS-aware			memset (rombuf, 0, aantal);
	strcpy(statbuf,filbin[i-1]);winstat();
	// DW: rewrote this quite a bit, to work with XMS and to avoid writing past the end of rombuf
	// Also made sure grot would be set if(PIC)
	// if(PIC)fread(picbuf,2,10000,fp);
	// else grot=fread(rombuf,8,mr,fp);
	// grot=grot*8;
	if(PIC) {
		 grot=fread(picbuf,1,20000,fp);
	}
	else {
		long l, g;
		for( l=0; l<aantal; l++ ) {
			XMSCurrent(l,1);
			if( (g=fread(rombuf,1,sizeof(rombuf),fp)) <= 0 ) break; //ARW: mixed pointers +implicit conversion
			l += sizeof(rombuf);
			grot += g;
		}
	}
	// grot=grot+8;               //KKK add
	fclose(fp);
	tcu_close_window(&window2);
	if(grot>aantal)grot=aantal;
	if(PIC)mPIC.fuses=picbuf[0x2007];
	if(PIC)R_fuses();
	memset(input_buffer,0,20);
}

void save_file(void){		//DW: added void
	//DW: unused		int mw=65534U;
	tcu_open_window(&window2, 17,5, 25,3,
				NULL,
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLACK, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);
	G:
	strset(filename,0);
	tcu_clear_window(&window2);
	tcu_wprintf(&window2,"filename:");
	tcu_wgets(&window2,11,filename,&length);
	strcat(filename,".bin");
	if(length!=-1){

		fp=fopen(filename,"wb");
		if(fp==NULL){
			goto G;
		}
		if(PIC)fwrite(picbuf,1,aantal,fp);
			//ARW: implicit conversion
		else {
			// DW: rewrote this a bit, to work with XMS
			long l, g;
			for( l=0; l<aantal; ) {
				XMSCurrent(l,0);
				if( l+(g=sizeof(rombuf)) > aantal ) g = aantal-l;
				fwrite(rombuf,1,g,fp);
				l += g;
			}
		}
		fclose(fp);

		tcu_close_window(&window2);
		fclose(fp);
	}
	strset(filename,0);
	tcu_close_window(&window2);
}

static void d_hexbyte(FILE *fp, int b)
{
		fprintf(fp,"%02X",b);
		check += b;
}


static void d_hexword(FILE *fp, int w)
{
		d_hexbyte(fp,w>>8);
		d_hexbyte(fp,w&0xFF);
}


/* d_hexrec(fp, buf, address, nw)
 *
 * Dumps nw words from buf in INHX8M or INHX16 format.
 *
 */

static void d_hexrec(FILE *fp, int *buf, int address, int nw)
{
	int i, n;
	unsigned w;

	while ( nw > 0 ) {
		check = 0;
		fprintf(fp,":");
		n = (nw > 8)? 8: nw;

		d_hexbyte(fp,2*n);
		d_hexword(fp,2*address);

		d_hexbyte(fp,0);
		for ( i=0; i < n; ++i ) {
			w = *buf++;

			w = SWAB(w);                    /* swap byte order */
			d_hexbyte(fp,w>>8);
			d_hexbyte(fp,w&0xFF);
		}
		d_hexbyte(fp,(-check)&0xFF);
		fprintf(fp,"\n");
		nw -= 8;
		address += 8;
	}
}

static void hexrec(FILE *fp, unsigned char huge *buf, long address, long nw)
{
	// DW: reworked for XMS
	long i, n, b;
	unsigned w;

	b=0;  // DW: added
	while ( nw > 0 ) {
		check = 0;
		fprintf(fp,":");
		n = (nw > 16)? 16: nw;

		d_hexbyte(fp,n);
		d_hexword(fp,address);

		d_hexbyte(fp,0);
		for ( i=0; i < n; ++i ) {
			w = *(buf+XMSCurrent(b,0));		// DW: Use b instead of *buf directly
			b++;
			d_hexbyte(fp,w);
		}
		d_hexbyte(fp,(-check)&0xFF);
		fprintf(fp,"\n");
		nw -= 16;
		address += 16;
	}
}

void hex_dump(void){		//DW: added void

	if(aantal>60000U)return;             //DW: added U
	tcu_open_window(&window2, 17,5, 25,3,
				NULL,
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLACK, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);
	G:
	strset(filename,0);
	tcu_clear_window(&window2);
	tcu_wprintf(&window2,"filename:");
	tcu_wgets(&window2,11,filename,&length);
	strcat(filename,".hex");
	if(length!=-1){
		fp=fopen(filename,"w");     //DW: clean up some extra {}'s here
		if(fp==NULL){
		   reset_timer();tcu_warnbeep();setup_timer(0xb0);
			goto G;
		}
		if(PIC){
			d_hexrec(fp,picbuf ,0,1024);
			d_hexrec(fp,picbuf+0x2007 ,0x2007,1);
			d_hexrec(fp,picbuf+0x2100 ,0x2100,64);
			fprintf(fp,":00000001FF\n");
		}
		else {
			hexrec(fp,rombuf ,0,grot);
			fprintf(fp,":00000001FF\n");
		}

		fclose(fp);
		tcu_close_window(&window2);
		fclose(fp);
	}
	strset(filename,0);
	tcu_close_window(&window2);
}

void getburn(void){		//DW: added void
	tcu_open_window(&window2, 38,3, 25,3,
				NULL,
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLACK, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

	tcu_clear_window(&window2);
	sprintf(input_buffer,"%d",burn);
	tcu_wprintf(&window2,"time(ms):");
	tcu_wgets(&window2,11,input_buffer,&length);
	if(length!=-1){
		burn=atoi(input_buffer);strcpy(statbur,input_buffer);winstat();
	}
	tcu_close_window(&window2);
	memset(input_buffer,0,20);
}

void getoff(void){		//DW: added void
	tcu_open_window(&window2, 38,3, 26,3,
				NULL,
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLACK, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);

	tcu_clear_window(&window2);
	sprintf(input_buffer,"%0.6lX",st);
	tcu_wprintf(&window2,"offset(HEX):");
	tcu_wgets(&window2,11,input_buffer,&length);
	if(length!=-1){
		sscanf(input_buffer,"%lX",&st);strcpy(statoff,input_buffer);winstat();
	}
	tcu_close_window(&window2);
	memset(input_buffer,0,13);
}

void setpin7(void)		//DW: added void
{
	if(pin7){
		pin7=0;
		strcpy(statpin7,"low");
		winstat();
	}
	else {
		pin7=1;
		strcpy(statpin7,"high");
		winstat();
	}
}

void setqe(void)		//DW: added void
{
	if(qe){
		qe=0;
		strcpy(statqe,"off");
		winstat();
	} else {
		qe=1;
		strcpy(statqe,"on");
		winstat();
	}
}

void winstat(void){		// DW: added void
	tcu_close_window(&window3);
	tcu_open_window(&window3, 19,10, 32,14,		 	// DW: Made wider for DIP switches 11 & 12
			 "STATUS",
			 tcu_colour_attrib (WHITE, LIGHTBLUE),
			 tcu_colour_attrib (BLUE, LIGHTGRAY),
			 tcu_colour_attrib (CYAN, RED),
			 TCU_BOX_SINGLE);
	tcu_clear_window(&window3);
	tcu_wprintf(&window3,"\n");
	tcu_wprintf(&window3,"    buffer: ");tcu_wprintf(&window3,statbuf); tcu_wprintf(&window3,"\n");
	tcu_wprintf(&window3,"    device: ");tcu_wprintf(&window3,statdev); tcu_wprintf(&window3,"\n");

	if(eep == 8 || eep == 10) {  // MCS-51,89Cx051 status
		tcu_wprintf(&window3,"    method: ");tcu_wprintf(&window3,"%d uS\n",AT89Cxx.tWP);
		tcu_wprintf(&window3,"  burntime: ");tcu_wprintf(&window3,"%d Pulse\n",AT89Cxx.Pulses);
	} else {
		tcu_wprintf(&window3,"    method: ");tcu_wprintf(&window3,statmet);tcu_wprintf(&window3,"\n");
		tcu_wprintf(&window3,"  burntime: ");tcu_wprintf(&window3,statbur); tcu_wprintf(&window3,"\n");
	}

	tcu_wprintf(&window3,"    offset: ");tcu_wprintf(&window3,statoff); tcu_wprintf(&window3,"\n");
	tcu_wprintf(&window3,"   24Cpin7: ");tcu_wprintf(&window3,statpin7); tcu_wprintf(&window3,"\n");
	tcu_wprintf(&window3," fastErase: ");tcu_wprintf(&window3,statqe);  tcu_wprintf(&window3,"\n");
	tcu_wprintf(&window3,"       lpt: ");tcu_wprintf(&window3,statlpt); tcu_wprintf(&window3,"\n");
							//ARW: added port status
	tcu_wprintf(&window3,"     DIPswitch Settings\n ");
	tcu_wprintf(&window3,dip);
	tcu_wprintf(&window3,"      1 2 3 4 5 6 7 8 9 0 1 2"); 	// DW: Added DIP switches 11 & 12
}

void menu_setup(void)		//DW: added void
{
	 tcu_open_window (&window1,
				1, 1,
				80, 25,
				"Window I",
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (WHITE, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
										TCU_BOX_DOUBLE);
	 tcu_wprintf(&window1," ");
	 tcu_set_mouse_mode (1);
	 r1 = tcu_define_menu (&file_m,
			 NULL,
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 file_options,
			 tcu_colour_attrib (LIGHTRED, MAGENTA));

	 r1 = tcu_define_menu (&device_m,
			 NULL,
												 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 device_options,
			 0);

	 r1 = tcu_define_menu (&settings_m,
			 NULL,
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE, settings_options,
			 tcu_colour_attrib (LIGHTRED, MAGENTA));

	 r1 = tcu_define_menu (&action_m,
			 NULL,
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 action_options,
			 tcu_colour_attrib (LIGHTRED, MAGENTA));

	 r1 = tcu_define_menu (&option_m,
			 NULL,
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 option_options,
			 tcu_colour_attrib (LIGHTRED, MAGENTA));

	 tcu_define_menu (&M24,
			 "24CXX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E24C,0);

	tcu_define_menu (&M27,
			 "27CXX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E27C,0);
	tcu_define_menu (&M28,
			 "28CXX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E28C,0);
	 tcu_define_menu (&M28F,
			 "28FXX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E28F,0);
	 tcu_define_menu (&M29F,
			 "29FXX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E29F,0);
	 tcu_define_menu (&MPIC50,
			 "12C50X",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 EPIC50,0);
	 tcu_define_menu (&M27xx,
			 "27XX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E27,0);
	 tcu_define_menu (&AT29Cxx,
			 "AT29Cxx",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E29C,0);
	 tcu_define_menu (&B_Block29C,
			 "Boot Block",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 BB29C,0);
	 tcu_define_menu (&MCS51,
			 "MCS-51",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E_MCS51,0);
	 tcu_define_menu (&AT2051,
			 "89Cx051",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E_AT2051,0);

	 tcu_define_menu (&LockBit89C,
			 "Lock Modes",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 LB89C,0);
	 tcu_define_menu (&AT49Fxx,
			 "AT49Fxxx",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E49F,0);

	 tcu_define_menu (&M25,
			 "AT25xxx",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E25C,0);

	 tcu_define_menu (&MPIC62,
			 "16C6xx",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 EPIC62,0);
	tcu_define_menu (&M93C,
			 "93CXX",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 E93C,0);
	 tcu_define_menu (&PICS,
			 "Pic Setting",
			 tcu_colour_attrib (YELLOW, CYAN),       /* Title */
			 tcu_colour_attrib (BLUE, CYAN),         /* Box */
			 tcu_colour_attrib (WHITE, MAGENTA),     /* Options */
			 tcu_colour_attrib (WHITE, BLUE),        /* Selected */
			 tcu_colour_attrib (LIGHTGRAY, MAGENTA), /* Deselected */
			 TCU_ESC_ESC | TCU_ESC_CNTL_C | TCU_ESC_PGUP | TCU_ESC_FUNC,
			 TCU_BOX_DOUBLE,
			 MPICS,0);
	 mlist[0] = &file_m;
	 mlist[1] = &device_m;
	 mlist[2] = &settings_m;
	 mlist[3] = &action_m;
	 mlist[4] = &option_m;
	 mlist[5] = NULL;

	 tcu_define_pulldown    (&pd,
				 tcu_colour_attrib (WHITE,BLUE),
				 tcu_colour_attrib (YELLOW,BLUE),
				 tcu_colour_attrib (YELLOW,RED),
				 headings,
				 tcu_colour_attrib (LIGHTGREEN, BLUE),
				 mlist);
}

void m24_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M24,26,2);
	i=tcu_read_menu_selection (&M24);
	tcu_remove_menu (&M24);
	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(256) ){eep=1;strcpy(statdev,"24C02");winstat();}break;
		case 2:if( Newaantal(512) ){eep=1;strcpy(statdev,"24C04");winstat();}break;
		case 3:if( Newaantal(1024) ){eep=1;strcpy(statdev,"24C08");winstat();}break;
		case 4:if( Newaantal(2048) ){eep=1;strcpy(statdev,"24C16");winstat();}break;
		case 5:if( Newaantal(4096) ){eep=2;strcpy(statdev,"24C32");winstat();}break;
		case 6:if( Newaantal(8192) ){eep=2;strcpy(statdev,"24C65");winstat();}break;
		case 7:if( Newaantal(16384) ){eep=2;strcpy(statdev,"24C128");winstat();}break;
		case 8:if( Newaantal(32768) ){eep=2;strcpy(statdev,"24C256");winstat();}break;
		case 9:if( Newaantal(65536) ){eep=2;strcpy(statdev,"24C512");winstat();}break;
	}
	strcpy(dip,"             ");  // DW: Added DIP switches 11 & 12
	winstat();
}

void m25_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M25,29,15);
	i = tcu_read_menu_selection (&M25);
	tcu_remove_menu (&M25);
	AT25xxx.init_code();
	switch(i){
		case 1:if( Newaantal(0x80) ){strcpy(statdev,"25010");}break;
		case 2:if( Newaantal(0x100) ){strcpy(statdev,"25020");}break;
		case 3:if( Newaantal(0x200) ){strcpy(statdev,"25040");}break;
		case 4:if( Newaantal(0x400) ){strcpy(statdev,"25080");}break;
		case 5:if( Newaantal(0x800) ){strcpy(statdev,"25160");}break;
		case 6:if( Newaantal(0x1000) ){strcpy(statdev,"25320");}break;
		case 7:if( Newaantal(0x2000) ){strcpy(statdev,"25640");}break;
		case 8:if( Newaantal(0x4000) ){strcpy(statdev,"25128");}break;
		case 9:if( Newaantal(0x8000) ){strcpy(statdev,"25256");}break;

	}
	if(i>0) { eep=AT25C;Dip(15);winstat();}
}


void Dip(int d){    //DW: added void
	switch(d){  // DW: Added DIP switches 11 & 12 to each of these
		case 1: strcpy(dip," ߳߳ܳ߳ܳ߳ܳܳ߳ܳ߳ܳ");break;
		case 2: strcpy(dip," ߳߳ܳ߳ܳ߳ܳܳ߳ܳ߳ܳ");break;
		case 3: strcpy(dip," ߳߳ܳܳ߳߳ܳ߳߳ܳ߳ܳ");break;

		case 4: strcpy(dip," ܳܳ߳ܳ߳ܳ߳߳߳ܳ߳ܳ");break;

		case 5: strcpy(dip," ܳܳܳ߳ܳ߳ܳܳ߳ܳ߳ܳ");break;

		case 6: strcpy(dip," ܳܳܳܳ߳߳ܳ߳߳ܳ߳ܳ");break;
		case 7: strcpy(dip," ܳܳ߳ܳ߳߳ܳܳܳ߳߳ܳ");break;
		case 8: strcpy(dip," ܳܳ߳ܳ߳߳ܳ߳߳ܳ߳ܳ");break;
		case 9: strcpy(dip," ܳܳܳܳܳܳ߳߳߳ܳ߳ܳ");break;

		case 10:strcpy(dip," ܳܳ߳ܳ߳߳ܳ߳ܳ߳ܳ߳");break;	 // DW: 040
		case 11:strcpy(dip," ܳܳ߳ܳ߳߳ܳ߳߳ܳܳ߳");break;	 // DW: 040
		case 12:strcpy(dip," ܳܳ߳ܳ߳߳ܳܳܳ߳ܳ߳");break;

		case 13:strcpy(dip," ܳ߳߳ܳ߳߳ܳ߳ܳ߳ܳ߳");break;	 // for AT89Cxx   (40pin)
		case 14:strcpy(dip," ܳܳ߳ܳ߳߳ܳ߳ܳ߳ܳ߳");break;	 // for AT89Cx051 (20pin)
		case 15:strcpy(dip,"             ");break;
		case 16:strcpy(dip," ܳ߳߳ܳ߳߳ܳܳܳ߳߳ܳ");break;  // for 27C010,27C020
		case 17:strcpy(dip," ܳ߳߳ܳ߳߳ܳ߳ܳ߳ܳ߳");break;	 // for 27C040

	}
}

void m27_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M27,27,4);
	i=tcu_read_menu_selection (&M27);
	tcu_remove_menu (&M27);
	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x1000) ){eep=0;pe=0;strcpy(statdev,"27C32");epr64=0;Dip(9);winstat();}break;
		case 2:if( Newaantal(0x2000) ){eep=0;pe=0;strcpy(statdev,"27C64");epr64=1;Dip(1);winstat();}break;
		case 3:if( Newaantal(0x4000) ){eep=0;pe=0;strcpy(statdev,"27C128");epr64=1;Dip(2);winstat();}break;
		case 4:if( Newaantal(0x8000) ){eep=0;pe=0;strcpy(statdev,"27C256");epr64=0;Dip(3);winstat();}break;     //DW: added U
		case 5:if( Newaantal(0x10000) ){eep=0;pe=0;strcpy(statdev,"27C512");epr64=0;Dip(4);winstat();}break;    //DW: added L
		case 6:if( Newaantal(0x20000) ){eep=0;pe=0;strcpy(statdev,"27C010");epr64=0;Dip(16);winstat();}break;   // Vpp + Vcc  ON DIPSW No.2
		case 7:if( Newaantal(0x40000) ){eep=0;pe=0;strcpy(statdev,"27C020");epr64=0;Dip(16);winstat();}break;   // Vpp + Vcc  ON DIPSW No.2
		case 8:if( Newaantal(0x80000) ){eep=0;pe=0;strcpy(statdev,"27C040");epr64=0;Dip(17);winstat();}break;	// DW: 040 support
//		case 8:message();
	}
}


void m28_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M28,27,5);
	i=tcu_read_menu_selection (&M28);
	tcu_remove_menu (&M28);
	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x2000) ){strcpy(statdev,"28C65,64");Dip(5);}break;
		case 2:if( Newaantal(0x4000) ){strcpy(statdev,"28C128");Dip(5);}break;
		case 3:if( Newaantal(0x8000) ){strcpy(statdev,"28C256");Dip(6);}break;  //DW: added U
		case 4:if( Newaantal(0x10000) ){strcpy(statdev,"28C512");Dip(7);}break;
		case 5:if( Newaantal(0x20000) ){strcpy(statdev,"28C010");Dip(7);}break;
		case 6:if( Newaantal(0x40000) ){strcpy(statdev,"28C020");Dip(7);}break;
		case 7:if( Newaantal(0x80000) ){strcpy(statdev,"28C040");Dip(7);}break;	//DW: 040 support
	}
	if(i>0 && i<8) { eep= 5,pe=1,winstat();}
}

void m28f_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M28F,27,6);
	i=tcu_read_menu_selection (&M28F);
	tcu_remove_menu (&M28F);
	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x2000) ) {strcpy(statdev,"28F64");Dip(5);}break;
		case 2:if( Newaantal(0x4000) ) {strcpy(statdev,"28F128");Dip(7);}break;
		case 3:if( Newaantal(0x8000) ) {strcpy(statdev,"28F256");Dip(7);}break;
		case 4:if( Newaantal(0x10000) ){strcpy(statdev,"28F512");Dip(7);}break;
		case 5:if( Newaantal(0x20000) ){strcpy(statdev,"28F010");Dip(7);}break;
		case 6:if( Newaantal(0x40000) ){strcpy(statdev,"28F020");Dip(7);}break;
		case 7:if( Newaantal(0x80000) ){strcpy(statdev,"28F040");Dip(12);}break;
	}
	if(i>0 && i<8) { eep=3,pe=0,winstat();}
}

void m29f_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M29F,27,7);
	i=tcu_read_menu_selection (&M29F);
	tcu_remove_menu (&M29F);

	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x2000) ) {strcpy(statdev,"29F64");Dip(5);}break;
		case 2:if( Newaantal(0x4000) ) {strcpy(statdev,"29F128");Dip(5);}break;
		case 3:if( Newaantal(0x8000) ) {strcpy(statdev,"29F256");Dip(6);}break;
		case 4:if( Newaantal(0x20000) ){strcpy(statdev,"29F512");Dip(7);}break;
		case 5:if( Newaantal(0x20000) ){strcpy(statdev,"29F010");Dip(7);}break;
		case 6:if( Newaantal(0x40000) ){strcpy(statdev,"29F020");Dip(7);}break;
		case 7:if( Newaantal(0x80000) ){strcpy(statdev,"29F040");Dip(7);}break;
	}
	if(i>0 && i<8) { eep=4,pe=0,winstat();}
}

void m50_r(void){		//DW: added void
	int i;
	tcu_display_menu(&MPIC50,27,9);
	i=tcu_read_menu_selection (&MPIC50);
	tcu_remove_menu (&MPIC50);

	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(511) ){strcpy(statdev,"12C508");winstat();}break;
		case 2:if( Newaantal(1023) ){strcpy(statdev,"12C509");winstat();}break;
	}
	Dip(15);winstat();  // DW: Added DIP switches 11 & 12
}

void m62_r(void){		//DW: added void
	int i;
	tcu_display_menu(&MPIC62,27,10);
	i=tcu_read_menu_selection (&MPIC62);
	tcu_remove_menu (&MPIC62);

	switch(i){
		case 1:aantal=512; {strcpy(statdev,"16C620");winstat();}break;
		case 2:aantal=1024;{strcpy(statdev,"16C621");winstat();}break;
		case 3:aantal=2048;{strcpy(statdev,"16C622");winstat();}break;
	}
	Dip(15);winstat();  // DW: Added DIP switches 11 & 12
}

void m93C_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M93C,27,9);
	i=tcu_read_menu_selection (&M93C);
	tcu_remove_menu (&M93C);
	m93Cxx.init_code();
	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x20) ){strcpy(statdev,"93C06 (8bit)");
			   }break;
		case 2:if( Newaantal(0x80) ){strcpy(statdev,"93C46 (8bit)");
			   }break;
		case 3:if( Newaantal(0x80) ){strcpy(statdev,"93LC46 (8bit)");
			   }break;
		case 4:if( Newaantal(0x100) ){strcpy(statdev,"93C56 (8bit)");
			   m93Cxx.shift_L(2);}break;
		case 5:if( Newaantal(0x100) ){strcpy(statdev,"93C57 (8bit)");
			   m93Cxx.shift_L(1);}break;
		case 6:if( Newaantal(0x200) ){strcpy(statdev,"93C66 (8bit)");
			   m93Cxx.shift_L(2);}break;
		case 7:if( Newaantal(0x400) ){strcpy(statdev,"93C76 (8bit)");
			   m93Cxx.shift_L(4);}break;
		case 8:if( Newaantal(0x800) ){strcpy(statdev,"93C86 (8bit)");
			   m93Cxx.shift_L(4);}break;
		case 9:if( Newaantal(0x20) ){strcpy(statdev,"93C06A (16bit)");
			   m93Cxx.shift_R(1); m93Cxx.bit16 = 2;}break;
		case 10:if( Newaantal(0x80) ){strcpy(statdev,"93C46A (16bit)");
			   m93Cxx.shift_R(1); m93Cxx.bit16 = 2;}break;
		case 11:if( Newaantal(0x100) ){strcpy(statdev,"93C56 (16bit)");
			   m93Cxx.shift_L(1); m93Cxx.bit16 = 2; }break;
		case 12:if( Newaantal(0x200) ){strcpy(statdev,"93C66 (16bit)");
			   m93Cxx.shift_L(1); m93Cxx.bit16 = 2;}break;
		case 13:if( Newaantal(0x400) ){strcpy(statdev,"93C76 (16bit)");
			   m93Cxx.shift_L(3); m93Cxx.bit16 = 2;}break;
		case 14:if( Newaantal(0x800) ){strcpy(statdev,"93C86 (16bit)");
			   m93Cxx.shift_L(3); m93Cxx.bit16 = 2;}break;
	}
	Dip(15);winstat();  // DW: Added DIP switches 11 & 12
}

void m27xx_r(void){		//DW: added void
	int i;
	tcu_display_menu(&M27xx,27,12);
	i=tcu_read_menu_selection (&M27xx);
	tcu_remove_menu (&M27xx);
	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x1000) ){strcpy(statdev,"2732");epr64=0;Dip(9);}break;
		case 2:if( Newaantal(0x2000) ){strcpy(statdev,"2764");epr64=1;Dip(1);}break;
		case 3:if( Newaantal(0x4000) ){strcpy(statdev,"27128");epr64=1;Dip(2);}break;
		case 4:if( Newaantal(0x8000) ){strcpy(statdev,"27256");epr64=0;Dip(3);}break;   //DW: added U
		case 5:if( Newaantal(0x10000) ){strcpy(statdev,"27512");epr64=0;Dip(4);}break;  //DW: added L
		case 6:if( Newaantal(0x20000) ){strcpy(statdev,"27010");epr64=0;Dip(16);}break;
		case 7:if( Newaantal(0x40000) ){strcpy(statdev,"27020");epr64=0;Dip(16);}break;
		case 8:if( Newaantal(0x80000) ){strcpy(statdev,"27040");epr64=0;Dip(10);}break;	//DW: 040 support
	}
	if(i>0 && i<9) { eep=6,pe=0,winstat();}

}

void AT29C_r(void)
{		//DW: added void
	int i;
	tcu_display_menu(&AT29Cxx,27,13);
	i=tcu_read_menu_selection (&AT29Cxx);
	tcu_remove_menu (&AT29Cxx);

	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x8000) ){
				strcpy(statdev,"AT29C256  (64)");
				Dip(6);sector_size = 64;}break;
		case 7:
		case 2:if( Newaantal(0x10000) ){
				strcpy(statdev,"AT29C512 (128)");
				Dip(7);sector_size = 128; }break;
		case 8:
		case 3:if( Newaantal(0x20000) ){
				strcpy(statdev,"AT29C010A (128)");
				Dip(7);sector_size = 128; }break;
		case 4:if( Newaantal(0x40000) ){
				strcpy(statdev,"AT29C020  (256)");
				Dip(7);sector_size = 256;}break;
		case 10:
		case 5:if( Newaantal(0x80000)){
				strcpy(statdev,"AT29C040A (256)");
				Dip(7);sector_size = 256;}break;
		case 6:if( Newaantal(0x80000)){
				strcpy(statdev,"AT29C040  (512)");
				Dip(7);sector_size = 512;}break;
		case 9:if( Newaantal(0x40000)){
				strcpy(statdev,"W29C020  (128)");
				Dip(7);sector_size = 128;}break;
	}
	if(i>0 && i<11) {
		 at29Cxxx.tWC = 20000;   // 20mS
		 eep=7,pe=0,winstat();
	}
}


void AT49F_r(void)
{		//DW: added void
	int i;
	tcu_display_menu(&AT49Fxx,27,15);
	i=tcu_read_menu_selection (&AT49Fxx);
	tcu_remove_menu (&AT49Fxx);

	switch(i){
		// DW: changed each of these so that they call Newaantal
		case 1:if( Newaantal(0x10000) )
			 { strcpy(statdev,"AT49F512");  Dip(7);}break;
		case 2:if( Newaantal(0x20000) )
			 { strcpy(statdev,"AT49F010"); 	Dip(7);}break;
		case 3:if( Newaantal(0x40000) )
			 { strcpy(statdev,"AT49F020"); 	Dip(7);}break;
		case 4:if( Newaantal(0x80000))
			 { strcpy(statdev,"AT49F040");	Dip(7);}break;
	}
	if(i > 0 && i < 5) { eep=AT49F; pe=0; winstat(); }
}

void PICM50_r(void){		//DW: added void
	int i;
	if(!PIC)return;

	tcu_display_menu(&PICS,26,7);
	i=tcu_read_menu_selection (&PICS);
	tcu_remove_menu (&PICS);

	switch(i){
		case 1:if(mPIC.pt)mPIC.pt=0;else mPIC.pt=PWRTE;break;
		case 2:if(mPIC.cp)mPIC.cp=0;else mPIC.cp=CP;break;
		case 3:if(mPIC.wd)mPIC.wd=0;else mPIC.wd=WDTE;break;
		case 4:{mPIC.osc++;if(mPIC.osc==4)mPIC.osc=0;}break;
	}

	mPIC.fuses=mPIC.cp+mPIC.pt+mPIC.wd+mPIC.osc;
	R_50fuses();
	picbuf[0x2007]=mPIC.fuses;
}

void PICM_r(void){		//DW: added void
	int i;
	if(!PIC)return;
	if(C50){
		PICM50_r();
		return;
	}
	tcu_display_menu(&PICS,26,7);
	i=tcu_read_menu_selection (&PICS);
	tcu_remove_menu (&PICS);

	switch(i){
		case 1:if(mPIC.cp)mPIC.cp=0;else mPIC.cp=CP;break;
		case 2:if(mPIC.pt)mPIC.pt=0;else mPIC.pt=PWRTE;break;
		case 3:if(mPIC.wd)mPIC.wd=0;else mPIC.wd=WDTE;break;
		case 4:{mPIC.osc++;if(mPIC.osc==4)mPIC.osc=0;}break;
	}
	if(F84){if(mPIC.pt)mPIC.pt=0;else mPIC.pt=PWRTE;}
	mPIC.fuses=mPIC.cp+mPIC.pt+mPIC.wd+mPIC.osc;
	R_fuses();
	picbuf[0x2007]=mPIC.fuses;
}

//----------------------------------------------

void get_settings(void){		//ARW: added proc to get last session settings
	//also can be used as input switch file to turn on
	//user options. first string on line ignored
	//no other comments allowed or spaces in strin
	char str[128];
	char portstr[10];
	int test_code=0;

	if((settings_fp=fopen("wileset.dat","r"))==NULL)
	  {printf("unable to open file wileset.dat\n Using defaults");
	  {reset_timer();delay(3000);setup_timer(0xb0);}
	  return;
	}else{
	  if(fscanf(settings_fp,"%s%X",str,&poort)==NULL){printf("no data, using defaults");
	    {reset_timer();delay(3000);setup_timer(0xb0);}
	     return;
	}
	ipoort=poort+1;
	spoort=poort+2;
	itoa(poort,portstr,16);
	strcpy(statlpt,(poort==0x378)?"lpt1, 0x":"lpt2, 0x");
	strcat(statlpt,portstr);
	fscanf(settings_fp,"%s%d",str,&burn);
	fscanf(settings_fp,"%s%d",str,&ep);
	fscanf(settings_fp,"%s%d",str,&fast);   //ARW: only way to set fast is hand edit wileset.dat
	fscanf(settings_fp,"%s%d",str,&e8751);  //ARW: only way to set e8751 is hand edit wileset.dat
	fscanf(settings_fp,"%s%d",str,&C89);  //ARW: only way to set c89 is hand edit wileset.dat
	//fscanf(settings_fp,"%s%d",str,&pe);   //ARW: device type tricky to save properly
	//fscanf(settings_fp,"%s%d",str,&eep);  //therefore not  implemented yet
	fscanf(settings_fp,"%s%d",str,&test_code);  //ARW:reads a terminating test code = ver no
	}
	itoa(burn,statbur,10);
	if (test_code!=85){printf("warning defaults file terminating test code/version\n does not match");
		ep=1;fast=0;e8751=0;C89=0;
		poort=0x378; ipoort=poort+1;  spoort=poort+2;
		{reset_timer();delay(3000);setup_timer(0xb0);}
	}
	if (ep==1)strcpy(statmet,"express");
	if ((ep==0)&&(fast==0))strcpy(statmet,"normal");
	if ((ep==0)&&(fast==1))strcpy(statmet,"fast");  //fast mode overules normal
	fclose ( settings_fp);
	if(e8751==1){Willem="8751 mode   ";Progver="warning untested beta  ";}//ARW program testing
	if(fast==1){Willem="fast mode   ";Progver="warning untested beta  ";}
	if(C89==1){Willem="89c51 mode   ";Progver="warning untested beta  ";
		e8751=0;}
	if(C89&fast){Willem="89c51 mode fast mode  ";Progver="warning untested beta  ";
		e8751=0;}
	if(fast&e8751){Willem="fast mode 8751 mode  ";Progver="warning untested beta  ";}
	winstat();
}

void save_settings(void)
{		//ARW: added proc
	int test_code=85;

	if((settings_fp=fopen("wileset.dat","w"))==NULL)
		  {printf("unable to open file wileset.dat");
		  {reset_timer();delay(3000);setup_timer(0xb0);}
	}
	else{
	fprintf(settings_fp,"port= %X\n",poort);
	fprintf(settings_fp,"burn= %d\n",burn);
	fprintf(settings_fp,"express= %d\n",ep);
	fprintf(settings_fp,"fast= %d\n",fast);
	fprintf(settings_fp,"e8751= %d\n",e8751);
	fprintf(settings_fp,"c89= %d\n",C89);
	//fprintf(settings_fp,"pe=%d\n",pe);        //ARW: device type tricky to save
	//fprintf(settings_fp,"eep=%d\n",eep);      //therefore not  implemented
	fprintf(settings_fp,"check_code= %d\n",test_code);
	}
	fclose ( settings_fp);
}

void arw_delay(long ticks){  //ARW: added universal delay
   //progressively calls longer less accurate
   //routines including itself! if required until done
   //range 1usec to 32 secs accuracy 1% ? not confirmed
   //uses timer.h dos.h
   //if (ticks<128)us_delay((int)ticks); //ARW removed, program not in one byte
   //else                               //reload mode by default
   // {set_timer(0x0B);                //this would make it safe but add overhead
	  if(ticks<=32767)ms_delay((int)ticks);
		 else if (ticks<=100000L){ms_delay(32767);arw_delay(ticks-32767L);} //recursion
				else delay((unsigned)(ticks/1000));
   //  }
}


void main (void)
{
	char k;
	setup();
	power_down();       //ARW: was powoff
	//powoff;assert;    //ARW: duplication
	ipoort=poort+1;     //ARW: added makes sure they are all related
	spoort=poort+2;
	menu_setup();
	// get_settings();  //ARW: added to get saved settings from last session
	versie();
	winstat();

	//-----	Microchip -----
	mPIC.fuses = XT;
	mPIC.cp=mPIC.pt=mPIC.wd=mPIC.osc = 0x00;
	mPIC.w7 = 0;

V:
	do {
		tcu_read_pulldown_selection (&pd, &r1, &r2);
		if (r1) {
			if(r1==1) {
			   switch(r2) {
				case 1: load_file(); break;
				case 2: load_bin(); break;
				case 3: testmenu(); break;
				case 4: {S3=0;S3_load();} break;
				case 5: {S3=1;S3_load();} break;
				case 6: save_file(); break;
				case 7: hex_dump(); break;
				case 8: viewbuffer(); break;
				case 9: {setup();save_settings(); //ARW:added save session settings
					/*powoff*/power_down();assert;tcu_remove_pulldown(&pd);
					tcu_close_window(&window1);reset_timer();XMSFree();/*DW*/exit(0);}
					 break;
				case 10:about(); break;
			    }
			 } // end if(r1==1)
	      //---------------------------------------
			if(r1==2) {
			   switch(r2) {
				case 1: {m24_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 2: {m27_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 3: {m28_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 4: {m28f_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 5: {m29f_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
					// DW: changed each of these so that they call Newaantal
				case 6: {aantal=1024; {strcpy(statdev,"16C84");C622=0;C89=0;F84=0;C93=0;
					Dip(15);winstat();C622=0;PIC=1;C622=0;C50=0;C93=0;}} break;  // DW: Added DIP switches 11 & 12
				case 7: {aantal=1024; {strcpy(statdev,"16F84");C89=0;F84=1;
					Dip(15);winstat();PIC=1;C50=0;}} break;  // DW: Added DIP switches 11 & 12
				case 8: {m50_r();C622=0;C50=1;C89=0;F84=0;PIC=1;C93=0;} break;
				case 9: {m62_r();PIC=1;C622=1;C50=0;C89=0;F84=0;PIC=1;C93=0;} break;
				case 10:{m93C_r();C622=0;C50=0;C89=0;F84=0;PIC=0;C93=1;Dip(15);winstat();} break;
				case 11:{m27xx_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 12:{AT29C_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 13:{MCS51_r(0);C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 14:{AT49F_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 15:{AT2051_r(0);C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;
				case 16:{m25_r();C622=0;PIC=0;C89=0;F84=0;C50=0;C93=0;} break;

			    }
		       } // end if(r1==2)

			if(r1==3){
			   switch(r2) {
				case 2:	if(fast==0){
					    ep=0;strcpy(statmet,"normal");
					    winstat();
					}else{ep=0;strcpy(statmet,"fast");winstat();}  //ARW:
					break;
				case 1: {ep=1;strcpy(statmet,"express");winstat();} break;
				case 3: getburn();break;
				case 4: getoff();break;
				case 5: setpin7();break;
				case 6: PICM_r();break;
				case 7: setqe();break;
			   }
			} // end r1==3

//------------------------ Menu Action --------------------------

			if(r1==4&&r2==1) {
				if(!test_hw(1)) {
					if(C50)P50read();       // read
					else if(PIC)		Pread();
					else if(C93)		read_93();
					else if(!eep)		CRead();
					else if(eep==3||eep==4)	CRead();
					else if(eep==5||eep==7||eep==9)	CRead_28C();
					else if(eep==6)		CRead();
					else if(eep==8||eep==10) CRead_AT89C();
					else if(eep==AT25C)	read_25C();
					else if(eep==2) 	read_65();
					else read_16();
				}
			}
			if(r1==4&&r2==2) {
				if(!test_hw(1)) {	//programmer
					if(C50)PIC508_pr();
					else if(PIC)	PIC_pr();
					else if(C93)	prog_93();
					else if(!eep)   prog_27xx(1);
					else if(eep==3)	prog_f28();
					else if(eep==4) prog_f29();
					else if(eep==5) prog_28C();
					else if(eep==6) prog_27xx(0);
					else if(eep==7) prog_29C();
					else if(eep==8||eep==10) prog_AT89C();
					else if(eep==9) prog_AT49F();
					else if(eep==AT25C) prog_25C();

					else if(eep==2) eprogram65();
					else prog_16();
				}
			}

			if(r1==4&&r2==3) {
				if(!test_hw(1)) {
					if (!eep)  	 Check();
					else if (eep==6) Check();
					else if (eep==7) Check();
					else if (eep==8||eep==10) empty_AT89C();
				}
			}
			if(r1==4&&r2==4) {
				if(!test_hw(1)) {
					if(C50)verify50();
					else if(PIC)		verify();
					else if(C93)		verify_93();
					else if(eep==0||eep==3||eep==4||eep==6) Compare();
					else if(eep==5||eep==7||eep==9) 	verify_28C();
					else if(eep==8||eep==10) 		verify_AT89C();
					else if(eep==2) 			verify_65();
					else if(eep==AT25C)			verify_25C();
					else verify_16();
				 }
			}
			if(r1==4&&r2==5) {
				if(!test_hw(1)){
				   switch(eep) {
					case 3:  erase_f28();  break;
					case 4:  erase_f29();  break;
					case 7:  erase_29C();  break;
					case 8:
					case 10: erase_AT89C(); break;
					case 9:  erase_AT49F(); break;
				   }
				}
			}
			if(r1==4&&r2==6) {
				if(!test_hw(1)) {
				   switch (eep) {
					case 7: id_29C(); break;
					case 8:
					case 10:id_AT89C();break;
					case 9: id_29C(); break;
				   }
				}
			}
			if(r1==4&&r2==7) {
				if(!test_hw(1)){
				   switch(eep) {
					case 7: if(getch_yes() == 1)
						Boot_Block_29C();
						break;
					case 9: if(getch_yes() == 1)
						Boot_Block_AT49F();
						break;
				   }
				 }
			}
			if(r1==4&&r2==8) {
				if(!test_hw(1)){
				   switch(eep) {
					case 8:
					case 10: lockbit_AT89C(); break;
				   }
				 }
			}
			if(r1==4&&r2==9)P_erase();
			if(r1==4&&r2==10){ClearBuf(); strcpy(statbuf,"empty");winstat();}
			if(r1==4&&r2==11){ChecksumBuf();}
	//--------------------------------------------------

			if(r1==5&&r2==1){poort=0x378;ipoort=0x379;spoort=0x37a;
			strcpy(statlpt,"lpt1");winstat();} //ARW: added
			if(r1==5&&r2==2){poort=0x278;ipoort=0x279;spoort=0x27a;
			strcpy(statlpt,"lpt2");winstat();} //ARW: added
			if(r1==5&&r2==3)test_hw(0);       //ARW: 0 sets to stop on hardware present
			if(r1==5&&r2==4)rb_set();
		}
		if(!PIC){tcu_close_window(&window7);mPIC.w7=0;}
	} while (r1);
	tcu_open_window(&window2, 24,13, 26,3,
				NULL,
				tcu_colour_attrib (WHITE, LIGHTBLUE),
				tcu_colour_attrib (BLACK, LIGHTGRAY),
				tcu_colour_attrib (CYAN, BLUE),
				TCU_BOX_SINGLE);
	tcu_wprintf(&window2," really Quit? ->N/n");
	k=getch();
	if(k=='n'|| k=='N'){
		tcu_close_window (&window2);
		goto V;
	}

	tcu_close_window (&window1);

	//powoff;assert;
	power_down();           //ARW: puts the programmer in safe known state
	reset_timer();          //duplication but better safe than sorry!
	XMSFree();		// DW
}
